/*Copyright (C) 'H' model transistor by B.S.J.W. Stephenson 19/2/2008 & 20/3/2008 & 7/5/2008 & 3/6/08*/
/* A.K.A the Black Box Model Transistor ,,Bibliographic ref. Mullard,Dio-tech etal '54->? */
/*
/*   This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

# include <stdio.h>
# include <limits.h> 
# include <stdarg.h>
# include <float.h>
# include <math.h>
# include <string.h>
# include "./BBBMTdefs6.h"

 newtran BBMT_Set_Capacitor_1_2_voltage_gradient_function( newtran *tran1 )
{

double C12V1start,C12V2corner,C12V3end,V12C1start,V12C2corner,V12C3end ;
double lnC12V1start,lnC12V2corner,lnC12V3end,lnV12C1start,lnV12C2corner,lnV12C3end ;
double lngradient1C12,lngradient2C12 ;

C12V1start = tran1->C12V1start ;

	lnC12V1start = log10(C12V1start) ;

tran1->lnC12V1start = lnC12V1start ;
 
C12V2corner = tran1->C12V2corner ;

	lnC12V2corner = log10(C12V2corner) ;

tran1->lnC12V2corner = lnC12V2corner ;

V12C1start = tran1->V12C1start ;

	lnV12C1start = log10(V12C1start) ;

tran1->lnV12C1start = lnV12C1start ;

V12C2corner = tran1->V12C2corner ;

	lnV12C2corner = log10(V12C2corner) ;

tran1->lnV12C2corner = lnC12V2corner ;

	lngradient1C12 = ( lnC12V2corner - lnC12V1start ) / ( lnV12C2corner - lnV12C1start ) ;

tran1->lngradient1C12 = lngradient1C12 ;

/* end gradient 1 */

C12V3end = tran1->C12V3end ;

	lnC12V3end = log10(C12V3end) ;

tran1->lnC12V3end = lnC12V3end ;

V12C3end = tran1->V12C3end ;

	lnV12C3end = log10(V12C3end) ;

tran1->lnV12C3end = lnV12C3end ;

	lngradient2C12 = ( lnC12V3end - lnC12V2corner ) / ( lnV12C3end - lnV12C2corner ) ;

tran1->lngradient2C12 = lngradient2C12 ;

/* end gradent 2 */

	return *tran1  ;

}/* end function BBMT_Set_Capacitor_1_2_voltage_gradient */

 newtran BBMT_Set_Capacitor_1_0_voltage_gradient_function( newtran *tran1 )
{

double C10V1start,C10V2corner1,C10V3corner2,C10V4end,V10C1start,V10C2corner1,V10C3corner2,V10C4end ;
double lnC10V1start,lnC10V2corner1,lnC10V3corner2,lnC10V4end,lnV10C1start,lnV10C2corner1 ;
double lngradient1C10,lngradient2C10,lngradient3C10,lnV10C3corner2,lnV10C4end ;

C10V1start = tran1->C10V1start ;

	lnC10V1start = log10(C10V1start) ;

tran1->lnC10V1start = lnC10V1start ;
 
C10V2corner1 = tran1->C10V2corner1 ;

	lnC10V2corner1 = log10(C10V2corner1) ;

tran1->lnC10V2corner1 = lnC10V2corner1 ;

V10C1start = tran1->V10C1start ;

	lnV10C1start = log10(V10C1start) ;

tran1->lnV10C1start = lnV10C1start ;

V10C2corner1 = tran1->V10C2corner1 ;

	lnV10C2corner1 = log10(V10C2corner1) ;

tran1->V10C2corner1 = lnV10C2corner1 ;

	lngradient1C10 = ( lnC10V2corner1 - lnC10V1start ) / ( lnV10C2corner1 - lnV10C1start ) ;

tran1->lngradient1C10 = lngradient1C10 ;

/* end gradient 1 */

C10V3corner2 = tran1->C10V3corner2 ;

	lnC10V3corner2 = log10(C10V3corner2) ;

tran1->lnC10V3corner2 = lnC10V3corner2 ;

V10C3corner2 = tran1->V10C3corner2 ;

	lnV10C3corner2 = log10(V10C3corner2) ;

tran1->lnV10C3corner2 = lnV10C3corner2 ;

	lngradient2C10 = ( lnC10V3corner2 - lnC10V2corner1 ) / ( lnV10C3corner2 - lnV10C2corner1 ) ;

tran1->lngradient2C10 = lngradient2C10 ;

/* end gradient 2 */

C10V4end = tran1->C10V4end ;

	lnC10V4end = log10(C10V4end) ;

tran1->lnC10V4end = lnC10V4end ;

V10C4end = tran1->V10C4end ;

	lnV10C4end = log10(V10C4end) ;

tran1->lnV10C4end = lnV10C4end ;

	lngradient3C10 = ( lnC10V4end - lnC10V3corner2 ) / ( lnV10C4end - lnV10C3corner2 ) ;

tran1->lngradient3C10 = lngradient3C10 ;

/* end gradient 3 */

	return *tran1  ;

}/* end function BBMT_Set_Capacitor_1_0_voltage_gradient */


 newtran BBMT_Generate_I_Cap_1_2_function(int n ,int pre_n ,int post_n, newtran *tran1 ) 
{

double Zc12part_two,Zc12part_one,Ic12,Ic12part_one,Ic12part_two,Ic12_theta,voltage_acrossC12_theta,voltage_acrossC12_absolute ;
double voltage_acrossC12_mag,I_leakage_Cap_1_2 ;

tran1->n = n ;
Zc12part_one = tran1->Zc12[n] ;

voltage_acrossC12_mag = tran1->voltage_acrossC12_mag ;	


	Ic12part_one = voltage_acrossC12_mag / Zc12part_one ;


Zc12part_two = tran1->Zc12[post_n] ;

	Ic12part_two = voltage_acrossC12_mag / Zc12part_two ;


I_leakage_Cap_1_2 = tran1->I_leakage_Cap_1_2 ;

	Ic12 = Ic12part_one + Ic12part_two + I_leakage_Cap_1_2 ;

voltage_acrossC12_theta = tran1->voltage_acrossC12_theta ;

	Ic12_theta = voltage_acrossC12_theta - M_PI_2 ; /* m_pi_2 is pi divided by 2 , really 90 degrees */



tran1->Ic12_theta[n] = Ic12_theta ; 
tran1->Ic12[n] = Ic12 ;


	return *tran1  ;


} /* end Generate_IC12_function */

 newtran BBMT_Generate_I_Cap_1_0_function(int n ,int pre_n ,int post_n, newtran *tran1 ) 
{

double Zc10part_one,Zc10part_two,Ic10,Ic10_theta,voltage_acrossC10_theta,voltage_acrossC10_absolute ;
double voltage_acrossC10_mag,Ic10part_one,Ic10part_two ;

Zc10part_one = tran1->Zc10[n] ;

voltage_acrossC10_mag = tran1->voltage_acrossC10_mag ;	

Ic10part_one = voltage_acrossC10_mag / Zc10part_one ;

Zc10part_two = tran1->Zc10[post_n] ;

	Ic10part_two = voltage_acrossC10_mag / Zc10part_two ;

	Ic10 = Ic10part_one + Ic10part_two ;

voltage_acrossC10_theta = tran1->voltage_acrossC10_theta ;

	Ic10_theta = voltage_acrossC10_theta - M_PI_2 ; /* m_pi_2 is pi divided by 2 , really 90 degrees */

tran1->Ic10_theta[n] = Ic10_theta ; 
tran1->Ic10[n] = Ic10 ;

	return *tran1  ;


} /* end Generate_IC10_function printf("\n =%G%s" ,," for Generate_I_Cap_1_0_function" ) ;*/



 newtran BBMT_Generate_size_Z_Cap_1_2_function(int n, newtran *tran1 ) 
{

double Utwo,Utwo_theta,voltage_acrossC12,V12C1start,V12C2corner ;
double voltage_acrossC12real,voltage_acrossC12imaginary,voltage_acrossC12_mag ;
double lngradient1C12,lngradient2C12,lnvoltage_acrossC12,lnV12C1start,lnV12C2corner ;
double Uone_internal,Uone_internal_theta,voltage_acrossC12_theta,voltage_acrossC12_square;
double voltage_acrossC12_absolute,C12,eC12,Zc12,lnC12V1start,lnC12V2corner ;
double ohmega_t,frequency,offset ;

/* generate Utwo internal minus Uone internal ( voltage across Capacitor 1 , 2 ) */

Utwo = tran1->Utwo_mag ;
Utwo_theta = tran1->Utwo_theta ;
Uone_internal = tran1->Uone_internal[n] ;
Uone_internal_theta = tran1->Uonemax_theta ;

	voltage_acrossC12real = ( Utwo * cos(Utwo_theta) ) - ( Uone_internal * cos(Uone_internal_theta)) ;

	voltage_acrossC12imaginary = ( Utwo *  sin(Utwo_theta) ) - ( Uone_internal * sin(Uone_internal_theta));

	voltage_acrossC12_square = pow(voltage_acrossC12real,2) + pow(voltage_acrossC12imaginary,2) ;

	voltage_acrossC12_theta = atan(voltage_acrossC12imaginary / voltage_acrossC12real) ;

tran1->voltage_acrossC12_theta = voltage_acrossC12_theta ;

	voltage_acrossC12_mag = sqrt(voltage_acrossC12_square) ;

tran1->voltage_acrossC12_mag = voltage_acrossC12_mag ;

	voltage_acrossC12_absolute = voltage_acrossC12_mag * sin(voltage_acrossC12_theta) ;

tran1->voltage_acrossC12_absolute = voltage_acrossC12_absolute ;

lnvoltage_acrossC12 = log10(voltage_acrossC12_absolute) ;

V12C1start = tran1->V12C1start ;

lnC12V1start = tran1->lnC12V1start ;

lnC12V2corner = tran1->lnC12V2corner ;

lngradient1C12 = tran1->lngradient1C12 ;

lngradient2C12 = tran1->lngradient2C12 ;

	if ( voltage_acrossC12_absolute < V12C1start )

	eC12 = ( lngradient1C12 * lnvoltage_acrossC12 ) + lnC12V1start ;/*short termist fix  + lnC12V1start ;*/
	else eC12 = ( lngradient2C12 * lnvoltage_acrossC12 ) + lnC12V2corner ;/*short termist fix + lnC12V2corner  ;*/

tran1->eC12 = eC12 ;

	 C12 = pow(10,eC12) ; 

tran1->C12 = C12 ;

	return *tran1  ;

}/* end Generate_size_Z_Cap_1_2_function */

 newtran BBMT_Generate_size_Z_Cap_1_0_function(int n, newtran *tran1 )
{
int BBMT_off ;
double Uone_internal,Uone_internal_theta,voltage_acrossC10_theta,voltage_acrossC10_square ;
double Uemitterin,Uemitterin_theta,voltage_acrossC10real,voltage_acrossC10imaginary ;
double lngradient1C10,lngradient2C10,lngradient3C10,lnvoltage_acrossC10,lnV10C1start,lnV10C2corner1 ;
double lnV10C3corner2,voltage_acrossC10_absolute,C10,eC10,Zc10,lnC10V1start,lnC10V2corner1 ;
double lnC10V3corner2,V10C1start,V10C2corner1,V10C3corner2,voltage_acrossC10_mag ;
double ohmega_t,frequency,offset ;

BBMT_off = tran1->BBMT_off ;

	if ( BBMT_off = 1 )
{
 n = 0 ;
}

Uone_internal = tran1->Uone ;
Uone_internal_theta = tran1->Uonemax_theta ;
Uemitterin = tran1->Uemitterin[n] ;
Uemitterin_theta = tran1->Uemitterin_theta[n] ;

	voltage_acrossC10real = ( Uone_internal * cos(Uone_internal_theta) ) - ( Uemitterin * cos(Uemitterin_theta));

	voltage_acrossC10imaginary = ( Uone_internal * sin(Uone_internal_theta) ) - ( Uemitterin * sin(Uemitterin_theta));

	voltage_acrossC10_theta = atan(voltage_acrossC10imaginary / voltage_acrossC10real) ;

tran1->voltage_acrossC10_theta = voltage_acrossC10_theta ;

	voltage_acrossC10_square = pow(voltage_acrossC10real,2) + pow(voltage_acrossC10imaginary,2) ;
	
	voltage_acrossC10_mag = sqrt(voltage_acrossC10_square) ;
	

tran1->voltage_acrossC10_mag = voltage_acrossC10_mag ;

	voltage_acrossC10_absolute = voltage_acrossC10_mag * sin(voltage_acrossC10_theta) ;

tran1->voltage_acrossC10_absolute = voltage_acrossC10_absolute ;

lnvoltage_acrossC10 = log10(voltage_acrossC10_absolute) ;

V10C1start = tran1->V10C1start ;

	if ( voltage_acrossC10_absolute < V10C1start )
{
lnC10V1start = tran1->lnC10V1start ;
lngradient1C10 = tran1->lngradient1C10 ;

	eC10 = ( lngradient1C10 * lnvoltage_acrossC10 ) + lnC10V1start ;
}

V10C2corner1 = tran1->V10C2corner1 ;

	 if ( voltage_acrossC10_absolute < V10C2corner1 )
{
lnC10V2corner1 = tran1->lnC10V2corner1 ;
lngradient2C10 = tran1->lngradient2C10 ;

	eC10 = ( lngradient2C10 * lnvoltage_acrossC10 ) + lnC10V2corner1 ;
}

V10C3corner2 = tran1->V10C3corner2 ;

	 if ( voltage_acrossC10_absolute < V10C3corner2 )
{
lnC10V3corner2 = tran1->lnC10V3corner2 ;
lngradient3C10 = tran1->lngradient3C10 ;

	eC10 = ( lngradient3C10 * lnvoltage_acrossC10 ) + lnC10V3corner2 ;
}
tran1->eC10 = eC10 ;

	C10 = pow(10,eC10) ;

tran1->C10 = C10 ;

	return *tran1  ;

}/* end Generate_size_Z_Cap_1_0_function */

newtran BBMT_Generate_Frequencies_Z_Cap_1_2_function(int n,int post_n, newtran *tran1 ) 
{

double Frequency_Uone,C12,omega ;
double Frequency_Utwo,Zc12part_one,Zc12part_two ;

omega = tran1->omega ;
C12 = tran1->C12 ;
Frequency_Uone = tran1->frequency_Uone ;
Frequency_Utwo = tran1->frequency_Utwo ;

	Zc12part_one = -1 / ( C12 * (omega * Frequency_Uone)) ;
	Zc12part_two = -1 / ( C12 * (omega * Frequency_Utwo)) ;

tran1->Zc12[n] = Zc12part_one ;
tran1->Zc12[post_n] = Zc12part_two ;

	return *tran1  ;

}/* end Generate_Frequencies_Z_Cap_1_2_function */

newtran BBMT_Generate_Frequencies_Z_Cap_1_0_function(int n,int post_n, newtran *tran1 ) 
{

double Frequency_Uone,C10,omega ;
double Frequency_Uzero,Zc10part_one,Zc10part_two ;

omega = tran1->omega ;
C10 = tran1->C10 ;
Frequency_Uone = tran1->frequency_Uone ;
Frequency_Uzero = tran1->frequency_Uzero ;

	Zc10part_one = -1 / ( C10 * (omega * Frequency_Uone)) ;
	Zc10part_two = -1 / ( C10 * (omega * Frequency_Uzero)) ;

tran1->Zc10[n] = Zc10part_one ;
tran1->Zc10[post_n] = Zc10part_two ;

	return *tran1  ;

}/* end Generate_Frequencies_Z_Cap_1_0_function */

newtran BBMT_Generate_thermal_leakage_Cap_1_2_function( newtran *tran1 ) 
{

double resistance_Icbo_low,resistance_Icbo_high,temperature_Icbo_low,temperature_Icbo_high,sink_temperature ;
double I_leakage_Cap_1_2,R_leakage_Cap_1_2,k_leakage_Cap_1_2,lnresistance_Icbo_low,lnresistance_Icbo_high ;
double voltage_acrossC12_absolute ;

	resistance_Icbo_low = tran1->resistance_Icbo_low ;

	lnresistance_Icbo_low = log(resistance_Icbo_low) ;

	resistance_Icbo_high = tran1->resistance_Icbo_high ;

	lnresistance_Icbo_high = log(resistance_Icbo_high) ;

temperature_Icbo_low = tran1->temperature_Icbo_low ; 
temperature_Icbo_high = tran1->temperature_Icbo_high ;
sink_temperature = tran1->sink_temperature ;
voltage_acrossC12_absolute = tran1->voltage_acrossC12_absolute ;

	k_leakage_Cap_1_2 = (( lnresistance_Icbo_high - lnresistance_Icbo_low ) / (temperature_Icbo_high - temperature_Icbo_low )) ;

	R_leakage_Cap_1_2 = resistance_Icbo_low * pow(M_E,(k_leakage_Cap_1_2 * sink_temperature)) ;

tran1->R_leakage_Cap_1_2 = R_leakage_Cap_1_2 ;

	I_leakage_Cap_1_2 = voltage_acrossC12_absolute / R_leakage_Cap_1_2 ;

tran1->I_leakage_Cap_1_2 = I_leakage_Cap_1_2 ;


	return *tran1  ;

}/* end Generate_thermal_leakage_Cap_1_2_function */

