/*Copyright (C) 'H' model transistor B.S.J.W. Stephenson 19/2/2008 & 20/3/2008 & 4/4/08 & 3/6/08 & 11/6/08 & 7/7/08 & 1/8/08 */
/* A.K.A the Black Box Model Transistor ,Bibliographic ref. Dio-tech , An Analog Electronics Companion etal '54->? */
/*
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

# include <stdio.h>
# include <limits.h> 
# include <stdarg.h>
# include <float.h>
# include <math.h>
# include <string.h>
# include "./BBBMTdefs6.h"

 newtran Set_forward_and_Reverse_descrip( newtran *tran1 )
{

tran1->BBMT_off = 0 ;
tran1->BBMT_off_forward = 0 ;

int comparison,BBMT_off ;
register char pointer1,pointer2,pointer3  ;
double frequency,offset,omega,frequency_Uone,frequency_Utwo,frequency_Uzero,Uonemax_theta,Utwoinittheta,Uemitterin_theta ;
double offset_emitter_collector,Uonemax,push_pull_Uone,Uemitterin,Utwoinit,push_pull_Utwo ;
 
 BBMT_Set_Delta_frequency(tran1) ;

pointer1 = tran1->npn[1] ;
Uonemax = tran1->Uonemax ;
Uonemax_theta = tran1->Uonemax_theta ;
pointer2 = 'p' ;
pointer3 = 'n' ;
Uemitterin = tran1->Uemitterin[0] ;
Uemitterin_theta = tran1->Uemitterin_theta[0] ;
Utwoinit = tran1->Utwoinit ;
Utwoinittheta = tran1->Utwoinittheta ;

	push_pull_Utwo = (Utwoinit * sin(Utwoinittheta)) - (Uemitterin * sin(Uemitterin_theta)) ;

	push_pull_Uone = Uonemax * sin(Uonemax_theta) ;
	
tran1->push_pull_Uone = push_pull_Uone ;
tran1->push_pull_Utwo = push_pull_Utwo ;
tran1->BBMT_off = 0 ;
tran1->BBMT_off_forward = 0 ;

	if (( pointer1 == pointer2 ) && ( push_pull_Uone < 0 ) && ( push_pull_Utwo < 0 ))
{
tran1->BBMT_off = 0 ;
tran1->BBMT_off_forward = 0 ;
BBMT_load_reverse_descript( tran1 ) ;
talloc() ;
} ;

	if (( pointer1 == pointer2 ) && ( push_pull_Uone < 0 ) && ( push_pull_Utwo > 0 ))
{
tran1->BBMT_off = 1 ;
tran1->BBMT_off_forward = 0 ;
BBMT_forwards_off_characteristic( tran1 ) ;
talloc() ;
} ;

	if (( pointer1 == pointer2 ) && (push_pull_Uone > 0 ) && ( push_pull_Utwo > 0 ))
{
tran1->BBMT_off = 0 ;
tran1->BBMT_off_forward = 0 ;
BBMT_load_forward_descript( tran1 ) ;
talloc() ;
} ;

	if (( pointer1 == pointer2 ) && (push_pull_Uone > 0 ) && ( push_pull_Utwo < 0 ))
{
tran1->BBMT_off = 1 ;
tran1->BBMT_off_forward = 1 ;
BBMT_reverse_off_characteristic( tran1 ) ;
talloc() ;
} ;

	if (( pointer1 == pointer3 ) && (push_pull_Uone > 0 ) && ( push_pull_Utwo < 0 ))
{
BBMT_load_reverse_descript( tran1 ) ;
tran1->BBMT_off = 0 ;
tran1->BBMT_off_forward = 0 ;
talloc() ;


} ;

	if (( pointer1 == pointer3 ) && (push_pull_Uone < 0 ) && ( push_pull_Utwo > 0 ))
{
BBMT_load_forward_descript( tran1 ) ;
tran1->BBMT_off = 0 ;
tran1->BBMT_off_forward = 0 ;
talloc() ;
} ;

	if (( pointer1 == pointer3 ) && (push_pull_Uone < 0 ) && ( push_pull_Utwo < 0 ))
{
BBMT_forwards_off_characteristic( tran1 ) ;
tran1->BBMT_off = 1 ;
tran1->BBMT_off_forward = 0 ;
talloc() ;

} ;

pointer1 = tran1->npn[1] ;

	if (( pointer1 == pointer3 ) && (push_pull_Uone > 0 ) && ( push_pull_Utwo > 0 ) && ( pointer1 != pointer2 ))
{
BBMT_reverse_off_characteristic( tran1 ) ;
tran1->BBMT_off = 1 ;
tran1->BBMT_off_forward = 1 ;
talloc() ;

} ;

 	return  *tran1 ;
}

newtran BBMT_Set_inverse_base_resistance_function( newtran *tran1 ) 
{

double inverse_base_resistance_low,inverse_base_resistance_high,inverted_base_voltage_low,inverted_base_voltage_high,push_pull_Uone ;
double I_inverted_base,R_inverted_base,k_inverted_base,lninverse_base_resistance_low,lninverse_base_resistance_high,corrector_constant ;

inverse_base_resistance_low = tran1->inverse_base_resistance ;

	lninverse_base_resistance_low = log(inverse_base_resistance_low) ;

inverse_base_resistance_high = tran1->inverse_base_resistance_high ;

	lninverse_base_resistance_high = log(inverse_base_resistance_high) ;

inverted_base_voltage_low = tran1->inverted_base_voltage_low ; 
inverted_base_voltage_high = tran1->inverted_base_voltage_high ;
push_pull_Uone = tran1->push_pull_Uone ;

/*push_pull_Uone = -6 ;/*testing*/

	k_inverted_base = (( lninverse_base_resistance_high - lninverse_base_resistance_low ) / ( inverted_base_voltage_high - inverted_base_voltage_low )) ;

corrector_constant = inverse_base_resistance_high / (inverse_base_resistance_high * pow(M_E,(k_inverted_base * inverted_base_voltage_high)))  ;

	R_inverted_base = (inverse_base_resistance_high * pow(M_E,(k_inverted_base * push_pull_Uone))) * corrector_constant ;

tran1->R_inverted_base = R_inverted_base ;
tran1->baseimp[0] = R_inverted_base ;

	return *tran1  ;

}/* end BBMT_Set_inverse_base_resistance_function */

newtran BBMT_Set_reverse_inverse_base_resistance_function( newtran *tran1 ) 
{

double reverse_inverse_base_resistance_low,reverse_inverse_base_resistance_high,reverse_inverted_base_voltage_low ;
double reverse_inverted_base_voltage_high,push_pull_Uone ;
double R_reverse_inverted_base,k_reverse_inverted_base,lnreverse_inverse_base_resistance_low ;
double lnreverse_inverse_base_resistance_high,corrector_constant ;

reverse_inverse_base_resistance_low = tran1->reverse_inverse_base_resistance ;

	lnreverse_inverse_base_resistance_low = log(reverse_inverse_base_resistance_low) ;

reverse_inverse_base_resistance_high = tran1->reverse_inverse_base_resistance_high ;

	lnreverse_inverse_base_resistance_high = log(reverse_inverse_base_resistance_high) ;

reverse_inverted_base_voltage_low = tran1->reverse_inverted_base_voltage_low ; 
reverse_inverted_base_voltage_high = tran1->reverse_inverted_base_voltage_high ;

push_pull_Uone = tran1->push_pull_Uone ;
/*push_pull_Uone = 0.022 ;/*testing*/
/*push_pull_Uone = 0.392 ;/*testing*/

	k_reverse_inverted_base = ( lnreverse_inverse_base_resistance_low - lnreverse_inverse_base_resistance_high ) / ( reverse_inverted_base_voltage_low - reverse_inverted_base_voltage_high ) ;

corrector_constant = reverse_inverse_base_resistance_low / (reverse_inverse_base_resistance_low * pow(M_E,(k_reverse_inverted_base * reverse_inverted_base_voltage_low)))  ;

	R_reverse_inverted_base = (reverse_inverse_base_resistance_low * pow(M_E,(k_reverse_inverted_base * push_pull_Uone))) * corrector_constant ;

tran1->R_reverse_inverted_base = R_reverse_inverted_base ;
tran1->baseimp[0] = R_reverse_inverted_base ;

	return *tran1  ;

}/* end BBMT_Set_reverse_inverse_base_resistance_function */

newtran BBMT_reverse_off_diode_leakage( newtran *tran1 ) 
{/* there should be a thermal modifier for this function , or should there ?  , characteristic data not available at present */

 double Utwo_absolute,reverse_off_diode_resistance,reverse_off_diode_current,reverse_off_diode_current_theta,Utwo_theta ;

Utwo_theta = tran1->Utwo_theta ;
Utwo_absolute = tran1->Utwo_absolute ;
reverse_off_diode_resistance = tran1->reverse_off_diode_resistance ;

	reverse_off_diode_current = Utwo_absolute / reverse_off_diode_resistance ;
	
tran1->reverse_off_diode_current = reverse_off_diode_current ;

	reverse_off_diode_current_theta = Utwo_theta ;

tran1->reverse_off_diode_current_theta  = Utwo_theta ;

	return *tran1  ;

}/* end BBMT_reverse_off_diode_leakage */

newtran BBMT_reverse_off_characteristic( newtran *tran1 ) 
{
  int n,noise_on ;
  double Itwo_total,Ione_total,beta ;
  
	BBMT_constants_function( tran1 ) ;
	BBMT_Utwo_absolute_function( tran1 ) ;
	BBMT_uone_not_zero_function( tran1 ) ;
	BBMT_inititial_conditions_function( tran1 ) ;
 	BBMT_Set_Capacitor_1_2_voltage_gradient_function( tran1 ) ;
 	BBMT_Set_Capacitor_1_0_voltage_gradient_function( tran1 ) ;
 	
        BBMT_Set_reverse_inverse_base_resistance_function( tran1 ) ;	/*Set_Base_impedance(0,0, tran1 ) ;*//* 1 & baseimp[0]		 */
  
        Set_I_one(1,0, tran1 ) ;  
	BBMT_Generate_size_Z_Cap_1_2_function(1, tran1 ) ;					     
	BBMT_Generate_size_Z_Cap_1_0_function(1, tran1 ) ; 					    
	BBMT_Generate_Frequencies_Z_Cap_1_2_function(1,2, tran1 ) ; 				     /* 1 & 2 post_n*/
	BBMT_Generate_Frequencies_Z_Cap_1_0_function(1,2, tran1 ) ; 				     /* 1 & 2 post_n*/
	BBMT_Generate_I_Cap_1_2_function(1,0,2, tran1 ) ;  					     /* 1 & Ic12[0] & 2 post_n		 */
	BBMT_Generate_I_Cap_1_0_function(1,0,2, tran1 ) ; 					     /* 1 & Ic10[0] & 2 post_n		 */

	BBMT_reverse_off_diode_leakage( tran1 ) ; 
	 					     
tran1->Itwo[1] = tran1->reverse_off_diode_current ;
	         
        BBMT_Power_function(1,1, tran1 ) ; 	/*itwo[n] Ione[pre_n] */	   
	BBMT_Thermal_function( tran1 ) ;   
			   
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;
	
     	BBMT_Generate_I_Cap_1_2_function(1,0,2, tran1 ) ;     
        BBMT_Power_function(1,1, tran1 ) ; 		   
	BBMT_Thermal_function( tran1 ) ;
	
/***************************************************************************************************************************************/

	 Generate_I_1_total_function(1,0,1,1, tran1 ) ;
	 Generate_I_2_total_function(1,0,1,1, tran1 ) ;
	 Generate_self_induced_load_function(1,0,1,1, tran1 ) ;
	 Generate_h11_function(1,0,1,1, tran1 ) ;
	 Generate_h21_function(1,0,1,1, tran1 ) ;
	 
Itwo_total = tran1->Itwo_total ;	 
Ione_total = tran1->Ione_total ;

	beta = Itwo_total / Ione_total ;
	 
tran1->beta[0] = beta ;
tran1->beta[7] = beta ; /* for noisey functions , ? h21 ?? oops ( you work it out )*/
	 
	 Generate_h22_function(1,0,1,1, tran1 ) ;
	 Generate_h12_function(1,0,1,1, tran1 ) ;
	 Generate_U_2_out_function(1,0,1,1, tran1 ) ;
	 Generate_U_1_out_function(1,0,1,1, tran1 ) ;
	 	
noise_on = tran1->noise_on ;

 if (noise_on = 1)
{
	noisey_function( tran1 ) ;
}

	  print_transistor_off_function( tran1 ) ;
	  
	  print_H_functions(1,0,1,1, tran1 ) ; /* itwo[n] beta[pre_n1] ione[pre_n2] */
	  	    
	return *tran1  ;

}/* end  BBMT_reverse_off_characteristic*/

newtran BBMT_forwards_off_characteristic( newtran *tran1 ) 
{
 
	BBMT_constants_function( tran1 ) ;
	BBMT_Utwo_absolute_function( tran1 ) ;
	BBMT_uone_not_zero_function( tran1 ) ;
	BBMT_inititial_conditions_function( tran1 ) ;
 	BBMT_Set_Capacitor_1_2_voltage_gradient_function( tran1 ) ;
 	BBMT_Set_Capacitor_1_0_voltage_gradient_function( tran1 ) ;	
        BBMT_Set_inverse_base_resistance_function( tran1 ) ;	/*Set_Base_impedance(0,0, tran1 ) ;*//* 1 & baseimp[0]		 */
 
        Set_I_one(1,0, tran1 ) ;  
	BBMT_Generate_size_Z_Cap_1_2_function(1, tran1 ) ;					     
	BBMT_Generate_size_Z_Cap_1_0_function(1, tran1 ) ; 					    
	BBMT_Generate_Frequencies_Z_Cap_1_2_function(1,2, tran1 ) ; 				     /* 1 & 2 post_n*/
	BBMT_Generate_Frequencies_Z_Cap_1_0_function(1,2, tran1 ) ; 				     /* 1 & 2 post_n*/
	BBMT_Generate_I_Cap_1_2_function(1,0,2, tran1 ) ;  					     /* 1 & Ic12[0] & 2 post_n		 */
	BBMT_Generate_I_Cap_1_0_function(1,0,2, tran1 ) ; 					     /* 1 & Ic10[0] & 2 post_n		 */
	  					    
tran1->Itwo[1] = 0 ;
	         
        BBMT_Power_function(1,1, tran1 ) ; 	/*itwo[n] Ione[pre_n] */	   
	BBMT_Thermal_function( tran1 ) ;   
			   
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;
	
     	BBMT_Generate_I_Cap_1_2_function(1,0,2, tran1 ) ;     
        BBMT_Power_function(1,1, tran1 ) ; 		   
	BBMT_Thermal_function( tran1 ) ;

/*********************************************************************************************************************************/

	 Generate_I_1_total_function(1,0,1,1, tran1 ) ;
	 Generate_I_2_total_function(1,0,1,1, tran1 ) ;
	 Generate_self_induced_load_function(1,0,1,1, tran1 ) ;
	 Generate_h11_function(1,0,1,1, tran1 ) ;
	 Generate_h21_function(1,0,1,1, tran1 ) ;
	 Generate_h22_function(1,0,1,1, tran1 ) ;
	 Generate_h12_function(1,0,1,1, tran1 ) ;
	 Generate_U_2_out_function(1,0,1,1, tran1 ) ;
	 Generate_U_1_out_function(1,0,1,1, tran1 ) ; 
	 
	  print_transistor_off_function( tran1 ) ;
	  print_H_functions(1,0,1,1, tran1 ) ; 
	  	    
	return *tran1  ;

}/* end  BBMT_off-characteristic*/

newtran print_transistor_off_function( newtran *tran1 ) 
{

int n,pre_n2,pre_n3 ;
n=1 ;
pre_n2 = 1 ;
pre_n3 = 1 ;

printf("\n\n Print output for verification , transistor in \"off\" condition");

printf("\n\n PowerDissipation=%G %s",tran1->PowerDissipation,"");
printf("\n Junction_temperature =%G %G%s",tran1->Junction_temperature ,"  ");
printf("\n sink_temperature=%G%s" ,tran1->sink_temperature," " ) ;

printf("\n\n Ione[pre_n2] =%G" , tran1->Ione[pre_n2] ) ;
int BBMT_off_forward ;

BBMT_off_forward = tran1->BBMT_off_forward ;

printf("\n\n tran1->BBMT_off_forward=%d %s" ,tran1->BBMT_off_forward," " ) ;

	if ( BBMT_off_forward < 1 ) 
{
printf("\n\n R_inverted_base=%G %s" ,tran1->R_inverted_base," " ) ;
}
	if ( BBMT_off_forward > 0 ) 
{
 printf("\n\n R_reverse_inverted_base=%G %s" ,tran1->R_reverse_inverted_base," " ) ;
}
	
printf("\n\n Itwo[n]=%G%s" , tran1->Itwo[n],"" ) ;
printf("\n\n (emitter out) Itwo_total=%G" , tran1->Itwo_total ) ;

printf("\n\n voltage_acrossC12_absolute=%G" ,tran1->voltage_acrossC12_absolute ) ;

printf("\n Zc12=%G" , tran1->Zc12[pre_n3] ) ;
printf("\n C12=%G" ,tran1->C12 ) ;
printf("\n I_leakage_Cap_1_2=%G%s" ,tran1->I_leakage_Cap_1_2,"" ) ;
printf("\n Ic12[pre_n3]= %G" , tran1->Ic12[pre_n3] ) ;
printf("\n Ic12_theta[pre_n3]= %G" , tran1->Ic12_theta[pre_n3] ) ;
printf("\n I_leakage_Cap_1_2=%G %s" ,tran1->I_leakage_Cap_1_2," " ) ;
printf("\n R_leakage_Cap_1_2=%G %s" ,tran1->R_leakage_Cap_1_2," " ) ;

printf("\n\n frequency_Uone=%G%s" ,tran1->frequency_Uone,"" ) ;
printf("\n frequency_Utwo=%G%s" ,tran1->frequency_Utwo,"" ) ;
printf("\n frequency_Uzero=%G%s" ,tran1->frequency_Uzero,"" ) ;

printf("\n\n voltage_acrossC10_absolute= %G" ,tran1->voltage_acrossC10_absolute ) ;

printf("\n Zc10= %G" , tran1->Zc10[pre_n3] ) ;
printf("\n C10= %G" ,tran1->C10 ) ;
printf("\n Ic10[pre_n3]= %G" ,tran1->Ic10[pre_n3] ) ;
printf("\n Ic10_theta[pre_n3]= %G%s" ,tran1->Ic10_theta[pre_n3] ) ;

	return *tran1  ;

}/* end  print_transistor_off_function*/



