/* Copyright (C) 'H' model transistor B.S.J.W. Stephenson 19/2/2008 & 20/3/2008  & 3/6/08*/
/* A.K.A the Black Box Model Transistor ,Bibliographic ref. Mullard,Dio-tech etal '54->? */
/*
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

# include <stdio.h>
# include <limits.h> 
# include <stdarg.h>
# include <float.h>
# include <math.h>
# include <string.h>
# include "./BBBMTdefs6.h"

 double inclination( double betaa , double betab ) ;

double inclination( double betaa,double betab )
{
  double incline ;

if ( betaa > betab )
  incline = -1 ;  
  else incline = 1 ;

 return incline ;
}

 newtran Set_Base_Impedance_Gradient( newtran *tran1 )
{

double baserone,basertwo,baserthree,lnIbasemax,lnIbasemin,lnbaseimps1,lnbaseimps2 ;
double Ibasemin,Ibasemax,lnbasertwo,lnbaserone,lnbaserthree ;

basertwo = tran1->basertwo ;

	lnbasertwo = log10(basertwo) ;

baserthree = tran1->baserthree ;

	lnbaserthree = log10(baserthree) ;

tran1->lnbaserthree = lnbaserthree ;
Ibasemin = tran1->Ibasemin ;

	lnIbasemin = log10(Ibasemin) ;

tran1->lnIbasemin = lnIbasemin ;
Ibasemax = tran1->Ibasemax ;

	lnIbasemax = log10(Ibasemax) ;

tran1->lnIbasemax = lnIbasemax ;

	lnbaseimps2 = ( lnbasertwo - lnbaserthree ) / ( lnIbasemax ) ;
 
tran1->lnbaseimps2 = lnbaseimps2 ;

/* end gradient set basimps2 */

baserone = tran1->baserone ;

	lnbaserone = log10(baserone) ;

tran1->lnbaserone = lnbaserone  ;
basertwo = tran1->basertwo ;

	lnbasertwo = log10(basertwo) ;

tran1->lnbasertwo = lnbasertwo ;
Ibasemin = tran1->Ibasemin ;

	lnIbasemin = log10(Ibasemin) ;

tran1->lnIbasemin = lnIbasemin ;

	lnbaseimps1 = (( lnbasertwo - lnbaserone ) / lnIbasemin) ;

tran1->lnbaseimps1 = lnbaseimps1 ;

	return *tran1  ;

} /* end function set_base_impedance_gradient */


 newtran Set_Base_impedance( int n , int pre_n , newtran *tran1 )
{

double Itwo[12],lnbaseimps1,lnbaseimps2,lnbaserone,lnItwo[12],baseimps[10],elnbaseimps[10] ;
double baseimp[10],baseimps1,baseimps2,baserone,basertwo,baserthree,Ibasemin,lnbasertwo ;

tran1->n = n ;

lnbaseimps2 = tran1->lnbaseimps2 ;
Itwo[pre_n] = tran1->Itwo[pre_n] ;
lnbasertwo = tran1->lnbasertwo  ;
Ibasemin = tran1->Ibasemin ;

	if ( Itwo[pre_n] >= Ibasemin ) 
{

	lnItwo[n] = log10(Itwo[pre_n]) ;

tran1->lnItwo[n] = lnItwo[n] ;
basertwo = tran1->basertwo  ;

	 baseimps[n] = (lnbaseimps2 * lnItwo[n]) + lnbasertwo ;

tran1->baseimps[n] = baseimps[n] ;

	elnbaseimps[n] = exp(baseimps[n]);

tran1->baseimp[n] = elnbaseimps[n] ;

/* next bit is a bit cheesey */

baseimp[n] = tran1->baseimp[n] ;
baserthree = tran1->baserthree ;

	if ( baseimp[n] < baserthree )
{
baseimp[n] = tran1->baserthree ;
tran1->baseimp[n] = baseimp[n] ;
}
}

Ibasemin = tran1->Ibasemin ;
Itwo[pre_n] = tran1->Itwo[pre_n] ;

	if ( Itwo[pre_n] < Ibasemin ) 
{
Ibasemin = tran1->Ibasemin ;
lnbaseimps1 = tran1->lnbaseimps1 ;
Itwo[pre_n] = tran1->Itwo[pre_n] ;
lnbaserone = tran1->lnbaserone  ;

	lnItwo[n] = log10(Itwo[pre_n]) ;

tran1->lnItwo[n] = lnItwo[n] ;

	baseimps[n] = (lnbaseimps1 * lnItwo[n]) + lnbaserone ;

tran1->baseimps[n] = baseimps[n] ;

	elnbaseimps[n] = exp(baseimps[n]) ;

tran1->baseimp[n] = elnbaseimps[n] ;
}
baseimp[n] = tran1->baseimp[n] ;

	return *tran1  ;

} /*end function set_base_impedance */

 newtran Set_I_one( int n , int pre_n , newtran *tran1 )
{ 

double Uone_mag,Uone_theta,Ione[10],baseimp[10],Uone_internal,Uone_internal_theta ;

baseimp[pre_n] = tran1->baseimp[pre_n] ;
Uone_internal = tran1->Uone_mag ;
Uone_internal_theta = tran1->Uone_theta ;

	Ione[n] = (Uone_internal * sin(Uone_internal_theta)) / baseimp[pre_n] ;

tran1->Ione[n] = Ione[n] ;
tran1->Ione_theta[n] = Uone_internal_theta ;
tran1->Uone_internal[n] = Uone_internal ;
tran1->Uone_internal_theta[n] = Uone_internal_theta ;
tran1->n = n ;
	return *tran1  ;

} /*end function set_I_one */

 newtran Set_Beta( int n , int pre_n , newtran *tran1 )
{

double Itwo[12],istop,icone,ictwo,icthree,icfour,icfive,bone,btwo,bthree,bfour,bfive,bsix,betaset,gradset,incline ;
double betaoffset,beta[12] ;

/* check Itwo[pre_n] not faulty */
/* Itwo[pre_n] is an absolute value */ 

tran1->n = n ;
Itwo[pre_n] = tran1->Itwo[pre_n] ;
istop = tran1->istop ;

	if (Itwo[pre_n] > istop )

/* start setting beta accurately first guess */

Itwo[pre_n] = tran1->Itwo[pre_n] ;
icfive = tran1->icfive ;

	if ( Itwo[pre_n] > icfive && Itwo[pre_n] <= istop )  
{

bsix = tran1->bsix ;
bfive = tran1->bfive ;
 
	betaset = bsix-bfive ;

tran1->betaset = betaset ;

tran1->incline = inclination(bfive,bsix) ;

istop = tran1->istop ;
icfive = tran1->icfive ;

	gradset = istop-icfive ;

tran1->gradset = gradset ;
bfive = tran1->bfive ;

	tran1->betaoffset=bfive ;
betaoffset = tran1->betaoffset ;
}

Itwo[pre_n] = tran1->Itwo[pre_n] ;
icfive = tran1->icfive ;
icfour = tran1->icfour ;

	if ( Itwo[pre_n] > icfour && Itwo[pre_n] <= icfive ) 
{
bfour = tran1->bfour ;
bfive = tran1->bfive ;
 
	betaset = bfive - bfour ;

tran1->betaset = betaset ;

tran1->incline = inclination(bfour,bfive) ;

icfour = tran1->icfour ;
icfive = tran1->icfive ;

	gradset = icfive - icfour ;

tran1->gradset = gradset ;
bfour = tran1->bfour ;

	tran1->betaoffset = bfour ;
betaoffset = tran1->betaoffset ;
}


Itwo[pre_n] = tran1->Itwo[pre_n] ;
icthree = tran1->icthree ;
icfour = tran1->icfour ;

	if ( Itwo[pre_n] > icthree && Itwo[pre_n] <= icfour ) 
{
bthree = tran1->bthree ;
bfour = tran1->bfour ;
 
	betaset = bfour - bthree ;

tran1->betaset = betaset ;

tran1->incline = inclination(bthree,bfour) ;

istop = tran1->istop ;
icthree = tran1->icthree ;

	gradset = icfour - icthree  ;

tran1->gradset = gradset ;
bthree = tran1->bthree ;

	tran1->betaoffset=bthree ;
betaoffset = tran1->betaoffset ;
}

Itwo[pre_n] = tran1->Itwo[pre_n] ;
ictwo = tran1->ictwo ;
icthree = tran1->icthree ;

	if ( Itwo[pre_n] > ictwo && Itwo[pre_n] <= icthree ) 
{
bthree = tran1->bthree ;
btwo = tran1->btwo ;

	betaset = bthree - btwo ;

tran1->betaset = betaset ;

tran1->incline = inclination(btwo,bthree) ;

icthree = tran1->icthree ;
ictwo = tran1->ictwo ;

	gradset = icthree - ictwo ;

tran1->gradset = gradset ;
btwo = tran1->btwo ;

	tran1->betaoffset=btwo ;

betaoffset = tran1->betaoffset ;
}

Itwo[pre_n] = tran1->Itwo[pre_n] ;
icone = tran1->icone ;
ictwo = tran1->ictwo ;
icthree = tran1->icthree ;

	if ( Itwo[pre_n] > icone && Itwo[pre_n] <= ictwo && Itwo[pre_n] < icthree ) /* this does not work with two components??? glibc236 gcc412*/
 {
btwo = tran1->btwo ; 
bone = tran1->bone ;

	betaset = btwo - bone ;

tran1->betaset = betaset ;

tran1->incline = inclination(bone,btwo) ;

ictwo = tran1->ictwo ;
icone = tran1->icone ;

	gradset = ictwo - icone ;

tran1->gradset = gradset ;
bone = tran1->bone ;

	tran1->betaoffset = bone ;

betaoffset = tran1->betaoffset ;
}
Itwo[pre_n] = tran1->Itwo[pre_n] ;
icone = tran1->icone ;

	if ( Itwo[pre_n] <= icone )
 {
bone = tran1->bone ;

	tran1->betaset = bone ;

betaset = tran1->betaset ;

tran1->incline = inclination(0,bone) ;

icone = tran1->icone ;

	tran1->gradset = icone ;

gradset = tran1->gradset ;

	tran1->betaoffset = 0 ;

betaoffset = tran1->betaoffset ;
}

/* next guess beta again */

betaset = tran1->betaset ;
gradset = tran1->gradset ;
Itwo[pre_n] = tran1->Itwo[pre_n] ;
betaoffset = tran1->betaoffset ;
/*incline = tran1->incline ; have removed incline after functionalisation from use as logs working now*/

	beta[n] = ((betaset/gradset) * Itwo[pre_n]) + betaoffset ;

tran1->beta[n] = beta[n] ;

	return *tran1  ;

} /* end function set beta */

 newtran  Set_I_two( int n , int pre_n1 , int pre_n2 , newtran *tran1 )
{

double Ione[10],beta[12],Itwo[12] ;

/* Ione[pre_n1] is an absolute value dittoe Itwo & itwo theta stays unchanged*/

tran1->n = n ;
beta[pre_n2] = tran1->beta[pre_n2] ;
Ione[pre_n1] = tran1->Ione[pre_n1] ;

	Itwo[n] = beta[pre_n2] * Ione[pre_n1] ;

tran1->Itwo[n] = Itwo[n] ;

	return *tran1  ;

} /*end set I_two */


 newtran BBMT_Power_function( int n , int pre_n , newtran *tran1 ) 
{

double Ione[10],Itwo[12],PowerDissipation,baseimp[10],Uone,Utwo_absolute ;
double cap_power_12,Ic12,Ic12_theta,cap_power_10,Ic10,Ic10_theta,new_cap_power_10 ;
double voltage_acrossC12_absolute,voltage_acrossC10_absolute,new_cap_power_12 ;
double Ic10current,Ic12current,Ione_power,Itwo_power,Uone_power,Utwo_absolute_power ;


Utwo_absolute = tran1->Utwo_absolute ;
Ione[pre_n] = tran1->Ione[pre_n] ;
Itwo[n]= tran1->Itwo[n] ;
baseimp[n] = tran1->baseimp[pre_n] ;
Uone = tran1->Uone ;
Ic10 = tran1->Ic10[1] ;
Ic12 = tran1->Ic12[1] ;
Ic10_theta = tran1->Ic10_theta[1] ;
Ic12_theta = tran1->Ic12_theta[1] ;
voltage_acrossC12_absolute = tran1->voltage_acrossC12_absolute ;
voltage_acrossC10_absolute = tran1->voltage_acrossC10_absolute ;

if (Ic12 < 0)
	Ic12current = Ic12 * -1 ;
	else
	Ic12current = Ic12 ;

if (Ic12 < 0)
	Ic10current = Ic10 * -1;
	else
	Ic10current = Ic10 ;

	cap_power_12 = voltage_acrossC12_absolute * Ic12current  ;

	cap_power_10 = voltage_acrossC10_absolute * Ic10current ;

if (cap_power_12 < 0)
	new_cap_power_12 = cap_power_12 * -1;
	else
	new_cap_power_12 = cap_power_12 ;

if (cap_power_10 < 0)
	new_cap_power_10 = cap_power_10 * -1;
	else
	new_cap_power_10 = cap_power_10 ;

if (Ione[pre_n] < 0)
	Ione_power = Ione[pre_n] * -1;
	else
	Ione_power = Ione[pre_n] ;

if (Itwo[n] < 0)
	Itwo_power = Itwo[n] * -1;
	else
	Itwo_power = Itwo[n] ;

if (Uone < 0)
	Uone_power = Uone * -1;
	else
	Uone_power = Uone ;

if (Utwo_absolute < 0)
	Utwo_absolute_power = Utwo_absolute * -1;
	else
	Utwo_absolute_power = Utwo_absolute ;

	PowerDissipation = ( Ione_power * Uone_power ) + ( Itwo_power * Utwo_absolute_power) + new_cap_power_12 + new_cap_power_10  ;

tran1->PowerDissipation = PowerDissipation ;

	return *tran1  ;

}/* end power dissipation function printf("\n =%G%s" ,," for _function" ) ;*/

 newtran BBMT_Thermal_function( newtran *tran1 ) 
{

double theta_total,theta_junction_coeficient,theta_case_sink,PowerDissipation ;
double theta_ambient_sink,Junction_temperature,Temperature_ambient,sink_temperature ;

PowerDissipation = tran1->PowerDissipation ;
theta_junction_coeficient = tran1->theta_junction_coeficient ;
theta_case_sink = tran1->theta_case_sink ; 
theta_ambient_sink = tran1->theta_ambient_sink ;

	theta_total = theta_junction_coeficient + theta_case_sink + theta_ambient_sink ;

tran1->theta_total = theta_total ;
Temperature_ambient = tran1->Temperature_ambient ;

	Junction_temperature = Temperature_ambient + ( theta_total * PowerDissipation ) ;

	sink_temperature = Temperature_ambient + ( ( theta_total - theta_ambient_sink ) * PowerDissipation ) ;

tran1->sink_temperature = sink_temperature ;
tran1->Junction_temperature = Junction_temperature ;

	return *tran1  ;

} /* end thermal function */

 newtran BBMT_Beta_change_function( int n , newtran *tran1 ) 
{

int Compound_thermal_beta_on ;
double Junction_temperature,Temperature_ambient,beta[12],Beta_change1 ;
double Beta_high,Beta_low,Beta_change,T_Beta_high,T_Beta_low,Beta_change2 ;

Beta_high = tran1->Beta_high ;
Beta_low = tran1->Beta_low ;
T_Beta_high = tran1->T_Beta_high ;
T_Beta_low = tran1->T_Beta_low ;
Junction_temperature = tran1->Junction_temperature ;
Temperature_ambient = tran1->Temperature_ambient ;
beta[n] = tran1->beta[n] ;
Compound_thermal_beta_on = tran1->Compound_thermal_beta_on ;

	Beta_change1 = (( Beta_high - Beta_low ) / ( Junction_temperature - Temperature_ambient )) + beta[n] ;
	Beta_change = Beta_change1 ;

	if ( T_Beta_high != 0 &&  T_Beta_low != T_Beta_high ) 
{ 
	Beta_change2 = (((( Beta_high - Beta_low ) / (T_Beta_high - T_Beta_low)) * Junction_temperature) / 100) + beta[n] ;
	Beta_change = Beta_change2 ;
}

	if ( Compound_thermal_beta_on == 1 )
{
	Beta_change = ( Beta_change2 + Beta_change1 ) / 2 ;
}

tran1->beta[n] = Beta_change ;

	return *tran1  ;

} /* end thermal beta change function */

newtran BBMT_Baseimp_change_thermal_function( int n , newtran *tran1 ) 
{
int Compound_thermal_baseimp_on ;
double baseimp[10],basimp_change,baseimp_high_T,baseimp_low_T,T_baseimp_high_T,T_baseimp_low_T ;
double Junction_temperature,Temperature_ambient,basimp_change2,basimp_change1 ;

baseimp[n] = tran1->baseimp[n] ;
baseimp_high_T = tran1->baseimp_high_T ;
baseimp_low_T = tran1->baseimp_low_T ;
T_baseimp_high_T = tran1->T_baseimp_high_T ;
T_baseimp_low_T = tran1->T_baseimp_low_T ;
Junction_temperature = tran1->Junction_temperature ;
Temperature_ambient = tran1->Temperature_ambient ;
Compound_thermal_baseimp_on = tran1->Compound_thermal_baseimp_on ; 

basimp_change1 = ((baseimp_high_T - baseimp_low_T)/( Junction_temperature - Temperature_ambient )) + baseimp[n] ;

basimp_change = basimp_change1 ;

 	if ( T_baseimp_high_T != 0 &&  T_baseimp_low_T != T_baseimp_high_T ) 
{ 
	basimp_change2 = (((( baseimp_high_T - baseimp_low_T ) / (T_baseimp_high_T - T_baseimp_low_T)) * Junction_temperature) / 100) + baseimp[n] ;
	basimp_change = basimp_change2 ;
}

	if ( Compound_thermal_baseimp_on == 1 )
{
	basimp_change = (basimp_change2 + basimp_change1 ) / 2 ;
}

tran1->baseimp[n] = basimp_change ; 

	return *tran1  ;

} /* end Basimp thermal change function */


