/* Copyright (C) 'H' model transistor B.S.J.W. Stephenson 19/2/2008 & 20/3/2008 & 4/4/08 & 3/6/08*/
/* A.K.A the Black Box Model Transistor ,Bibliographic ref. Mullard,Dio-tech etal '54->? */
/*
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

# include <stdio.h>
# include <limits.h> 
# include <stdarg.h>
# include <float.h>
# include <math.h>
# include <string.h>
# include "./BBBMTdefs6.h"

ptrbbtnode talloc(void)
{
	return (ptrbbtnode) malloc(sizeof(newtran)) ;
}

newtran BBMT_initialise_function( newtran *tran1 )
{
int BBMT_off ;

BBMT_off = tran1->BBMT_off ;

	if ( BBMT_off != 0 ) 
{
Set_forward_and_Reverse_descrip( tran1 ) ;
}

BBMT_off = tran1->BBMT_off ;

	if ( BBMT_off == 0 ) 
{
BBMT_constants_function( tran1 ) ;
BBMT_Utwo_absolute_function( tran1 ) ;
BBMT_uone_not_zero_function( tran1 ) ;
BBMT_inititial_conditions_function( tran1 ) ;
BBMT_program_function( tran1 ) ;	
}

	return *tran1  ;
	
} /* end of initialise_function */    

newtran BBMT_load_forward_descript( newtran *tran1 )
{
double bone,btwo,bthree,bfour,bfive,bsix,Beta_high,Beta_low ;
double icone,ictwo,icthree,icfour,icfive,istop,T_Beta_high,T_Beta_low ;
double baserone,basertwo,baserthree,Ibasemin,Ibasemax,baseimp_high_T,baseimp_low_T ;

bone = tran1->F_bone ;
 tran1->bone = bone ;
btwo = tran1->F_btwo ;
 tran1->btwo = btwo ;
bthree = tran1->F_bthree ;
 tran1->bthree = bthree ;
bfour = tran1->F_bfour ; 
 tran1->bfour = bfour ;
bfive = tran1->F_bfive ; 
 tran1->bfive = bfive ;
bsix = tran1->F_bsix ;
 tran1->bsix = bsix ;
Beta_high = tran1->F_Beta_high ;
 tran1->Beta_high = Beta_high ;
Beta_low = tran1->F_Beta_low ;
 tran1->Beta_low = Beta_low ;
T_Beta_high = tran1->FT_Beta_high ;
 tran1->T_Beta_high = T_Beta_high ;
T_Beta_low = tran1->FT_Beta_low ;
 tran1->T_Beta_low = T_Beta_low ;

icone = tran1->F_icone ;
 tran1->icone = icone ;
ictwo = tran1->F_ictwo ;
 tran1->ictwo = ictwo ;
icthree = tran1->F_icthree ;
 tran1->icthree = icthree ;
icfour = tran1->F_icfour ;
 tran1->icfour = icfour ;
icfive = tran1->F_icfive ;
 tran1->icfive = icfive ;
istop =  tran1->F_istop ;
 tran1->istop = istop ;

baserone = tran1->F_baserone ;
 tran1->baserone = baserone ;
basertwo = tran1->F_basertwo ;
 tran1->basertwo = basertwo ;
baserthree = tran1->F_baserthree ;
 tran1->baserthree = baserthree ;

Ibasemin = tran1->F_Ibasemin ;
 tran1->Ibasemin = Ibasemin ;
Ibasemax = tran1->F_Ibasemax ;
 tran1->Ibasemax = Ibasemax ;
 
baseimp_high_T = tran1->F_baseimp_high_T ;
 tran1->baseimp_high_T = baseimp_high_T ;
baseimp_low_T = tran1->F_baseimp_low_T ;
 tran1->baseimp_low_T = baseimp_low_T ;
  
 tran1->T_baseimp_high_T = tran1->FT_baseimp_high_T ;
 tran1->T_baseimp_low_T = tran1->FT_baseimp_low_T ;
 
 	return *tran1  ;

} /* end BBMT_load_forward_descript */
 
 newtran BBMT_load_reverse_descript( newtran *tran1 )
{

double bone,btwo,bthree,bfour,bfive,bsix,Beta_high,Beta_low ;
double icone,ictwo,icthree,icfour,icfive,istop ;
double baserone,basertwo,baserthree,Ibasemin,Ibasemax,baseimp_high_T,baseimp_low_T ;

bone = tran1->R_bone ;
 tran1->bone = bone * -1 ;
btwo = tran1->R_btwo ; 
 tran1->btwo = btwo * -1 ;
bthree = tran1->R_bthree ; 
 tran1->bthree = bthree * -1 ;
bfour = tran1->R_bfour ; 
 tran1->bfour = bfour * -1 ;
bfive = tran1->R_bfive ; 
 tran1->bfive = bfive * -1 ;
bsix = tran1->R_bsix ; 
 tran1->bsix = bsix * -1 ;
 
 tran1->Beta_high = tran1->R_Beta_low ;
 tran1->Beta_low = tran1->R_Beta_high ;
 tran1->T_Beta_high = tran1->RT_Beta_low ;
 tran1->T_Beta_low = tran1->RT_Beta_high ;

 tran1->icone = tran1->R_icone ;
 tran1->ictwo = tran1->R_ictwo ;
 tran1->icthree = tran1->R_icthree ;
 tran1->icfour = tran1->R_icfour ;
 tran1->icfive = tran1->R_icfive ;
 tran1->istop =  tran1->R_istop ;

 tran1->baserone = tran1->R_baserone ;
 tran1->basertwo = tran1->R_basertwo ;
 tran1->baserthree = tran1->R_baserthree ;

 tran1->Ibasemin = tran1->R_Ibasemin ;
 tran1->Ibasemax = tran1->R_Ibasemax ;
 
 tran1->baseimp_high_T = tran1->R_baseimp_high_T ;
 tran1->baseimp_low_T = tran1->R_baseimp_low_T ;
 tran1->T_baseimp_high_T = tran1->RT_baseimp_high_T ;
 tran1->T_baseimp_low_T = tran1->RT_baseimp_low_T ;
   
 	return *tran1  ;

} /* end BBMT_load_reverse_descript */
 
newtran BBMT_Set_Delta_frequency( newtran *tran1 )
{

double configuration ;

configuration = tran1->configuration ;

	if ( configuration = 1 ) 
{
	tran1->Delta_frequency = tran1->Delta_frequency_one ;
}

	else if ( configuration = 2 ) 
{
	tran1->Delta_frequency = tran1->Delta_frequency_two ;
}

	else if ( configuration = 3 ) 
{
	tran1->Delta_frequency = tran1->Delta_frequency_three ;
}

	else if ( configuration = 4 ) 
{
	tran1->Delta_frequency = tran1->Delta_frequency_four ;
}

 	return *tran1 ;
	
} /* end BBMT_Set_Delta_frequency */

 main()
{

 newtran tran ;
 newtran *tran1 ;
 tran1 = &tran ;
 
        /* the following data has been massaged for low current and estimated */
                     /* for performance, do not trust it */

 tran1->F_bone = 33.6  ;
 tran1->F_btwo = 105  ;
 tran1->F_bthree = 273  ;
 tran1->F_bfour = 420  ;
 tran1->F_bfive = 420  ;
 tran1->F_bsix = 126  ;
 tran1->F_Beta_high = 590 ;
 tran1->F_Beta_low = 420 ;
 tran1->FT_Beta_high = 25 ;
 tran1->FT_Beta_low = 20 ;

 tran1->R_bone = 1 ;
 tran1->R_btwo = 3.37e-3 ;
 tran1->R_bthree = 0.45 ;
 tran1->R_bfour = 95 ;
 tran1->R_bfive =  100 ;
 tran1->R_bsix = 101  ;/*  do not trust this estimate */
 tran1->R_Beta_high = 120 ;/*  do not trust this estimate */
 tran1->R_Beta_low = 85 ;/*  do not trust this estimate */
 tran1->RT_Beta_high = 25 ;/*  do not trust this estimate */
 tran1->RT_Beta_low = 20 ;/*  do not trust this estimate */

 tran1->F_icone =  0.001e-3 ;
 tran1->F_ictwo =  0.008e-3 ;
 tran1->F_icthree = 0.2e-3 ;
 tran1->F_icfour = 10e-3 ;
 tran1->F_icfive = 50e-3 ;
 tran1->F_istop =  200e-3 ;

 tran1->R_icone = 0.00e-3 ;
 tran1->R_ictwo = 0.07e-3 ;
 tran1->R_icthree = 2.43e-3 ;
 tran1->R_icfour = 13.70e-3 ;
 tran1->R_icfive = 15.30e-3 ;
 tran1->R_istop = 200e-3 ;/*  do not trust this estimate */

 tran1->F_baserone = 333000 ;
 tran1->F_basertwo = 1733333  ;
 tran1->F_baserthree = 800 ;
 tran1->F_Ibasemin = 6.5e-5 ;
 tran1->F_Ibasemax = 0.82e-3 ;
 tran1->F_baseimp_high_T = 542 ;
 tran1->F_baseimp_low_T = 667 ;
 tran1->FT_baseimp_high_T = 25 ;
 tran1->FT_baseimp_low_T = 20 ;

 tran1->R_baserone = 17 ;
 tran1->R_basertwo = 5.2e3 ;
 tran1->R_baserthree = 250 ;/*  do not trust this estimate */
 tran1->R_Ibasemin = 23e-3 ;
 tran1->R_Ibasemax = 200e-3 ;/*  do not trust this estimate */
 tran1->R_baseimp_high_T = 5e3 ;/*  do not trust this estimate */
 tran1->R_baseimp_low_T = 5.2e3 ;/*  do not trust this estimate */
 tran1->RT_baseimp_high_T = 25 ;
 tran1->RT_baseimp_low_T = 20 ;

 tran1->Delta_frequency_one = 200 ;
 tran1->Delta_frequency_two = 200 ;/*  do not trust this estimate */
 tran1->Delta_frequency_three = 10 ;/*  do not trust this estimate */
 tran1->Delta_frequency_four = 10 ;/*  do not trust this estimate */

 tran1->pin_resistance_one = 1 ; /* required by noise function ? wether it is required once operating in circuit */
 tran1->pin_resistance_two = 1 ;
 tran1->pin_resistance_zero = 1 ;
 
 tran1->vemitterbasemax =  5  ; /* not used*/
 
 tran1->theta_junction_coeficient = 200 ;
 tran1->theta_case_sink = 83 ;
 tran1->theta_ambient_sink = 40 ;
 tran1->Temperature_ambient = 27 ;

 tran1->C12V1start = 6e-12 ;
 tran1->C12V2corner = 5e-12 ;
 tran1->C12V3end = 3.5e-12 ;

 tran1->C10V1start = 3.5e-12 ;
 tran1->C10V2corner1 = 2.2e-12 ;
 tran1->C10V3corner2 = 1.2e-12 ;
 tran1->C10V4end = 1.1e-12 ;

 tran1->V12C1start = 0.4 ;
 tran1->V12C2corner = 1.5 ;
 tran1->V12C3end = 4 ;

 tran1->V10C1start = 0.4 ;
 tran1->V10C2corner1 = 4 ;
 tran1->V10C3corner2 = 25 ;
 tran1->V10C4end = 40 ;

 tran1->resistance_Icbo_low = 6e11 ;
 tran1->resistance_Icbo_high = 1.5e8 ;
 tran1->temperature_Icbo_low = 0 ; 
 tran1->temperature_Icbo_high = 150 ;

 tran1->Rg_optimal_one = 2e3 ;	/* grounded emitter base */
 tran1->Rg_optimal_two = 2e3 ;	/* grounded collector base */
 tran1->Rg_optimal_three = 50 ;	/* grounded base emitter */
 tran1->Rg_optimal_four = 50 ;	/* grounded base collector */
 tran1->Noise_figure_one = 2 ;
 tran1->Noise_figure_two = 2 ;
 tran1->Noise_figure_three = 12 ;
 tran1->Noise_figure_four = 12 ;
 
 tran1->Compound_thermal_baseimp_on = 1 ;
 tran1->Compound_thermal_beta_on = 0 ;
 
 tran1->configuration = 1 ;/* grounded emitter base ,1 to 4 , as per rg_optimal */
 tran1->noise_on = 1 ;
 tran1->K_boltz = 1.38066e-23 ;

 tran1->inverted_base_voltage_low = -6 ; 
 tran1->inverted_base_voltage_high = -1.14 ;
 tran1->inverse_base_resistance = 60e3 ;
 tran1->inverse_base_resistance_high = 11e6 ;

 tran1->reverse_off_diode_resistance = 1.14e3 ;
 
 tran1->reverse_inverted_base_voltage_low = 22e-3 ; 
 tran1->reverse_inverted_base_voltage_high = 392e-3 ;
 tran1->reverse_inverse_base_resistance = 1.134 ;
 tran1->reverse_inverse_base_resistance_high = 509 ;
 
/*these should be read from node network */

int comparison ;
char pointer1,pointer2,pointer3  ;
double frequency,offset,omega,frequency_Uone,frequency_Utwo,frequency_Uzero,Uonemax_theta,Utwoinittheta,Uemitterin_theta ;
double offset_emitter_collector,Uonemax,dcbias0,dcbias1,dcbias2 ;

offset = 1.745435e-2 ;/*M_PI_2 ;/*1.745435e-2 ;/*1e-32 ;/*M_PI_2 ;1 degree appears to be minimum offset( this to approx 4 dec.-pla.)*/
omega = 2 * M_PI ;


 tran1->omega = omega ;
 tran1->offset = offset ;
 tran1->frequency_Uone = 0.001 ;
 tran1->frequency_Utwo = 2.5e-1 ;
 tran1->frequency_Uzero = 0.001 ;

 tran1->Uonemax = 0.19 ;/*-0.6 ;/*-0.19 ;/*0.668 ;*/
 Uonemax = tran1->Uonemax ;


	Uonemax_theta = ( omega * frequency_Uone ) + offset  ;
 tran1->Uonemax_theta = Uonemax_theta ;

 tran1->Utwoinit  = 4.5001 ;/*-8.668 ;*/

	Utwoinittheta = ( omega * frequency_Utwo ) + offset  ;
 tran1->Utwoinittheta = Utwoinittheta ;

 tran1->Uemitterin[0] = 0.001 ;

	Uemitterin_theta = ( omega * frequency_Uzero ) + offset  ;
 tran1->Uemitterin_theta[0] = Uemitterin_theta ;

 tran1->npn[0] = 'n' ; tran1->npn[1] = 'p' ; tran1->npn[2] = 'n'; tran1->npn[3] = '\0' ;
 tran1->descriptor[0] = 'B' ;tran1->descriptor[1] = 'C' ;tran1->descriptor[2] = '5' ;tran1->descriptor[3] = '4' ;tran1->descriptor[4] ='7' ;tran1->descriptor[5] = 'C' ;tran1->descriptor[6] = '\0' ; 

 tran1->n = 0 ;
	
/*Set_forward_and_Reverse_descrip( tran1 ) ; to operate */
tran1->BBMT_off = 1 ;

talloc() ;

BBMT_initialise_function( tran1 ) ;

}/* end of main */ 


