/* Copyright (C) 'H' model transistor B.S.J.W. Stephenson 19/2/2008 & 20/3/2008 & 4/4/08 & 3/6/08 & 11/6/08 & 7/7/08 */
/* A.K.A the Black Box Model Transistor ,Bibliographic ref. Dio-tech , An Analog Electronics Companion etal '54->? */
/*
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

# include <stdio.h>
# include <limits.h> 
# include <stdarg.h>
# include <float.h>
# include <math.h>
# include <string.h>
# include "./BBBMTdefs6.h"

 newtran Generate_R_G_source_function( int pre_n1 , newtran *tran1 ) 
{

int configuration ;
double h11,h22,h12,h21,deltah_grounded_emitter_base,rg_input,deltah,rg_input_square ;
double pin_resistance_one,pin_resistance_zero,pin_resistance_two,deltah_grounded_collector_base ;
double deltah_grounded_base_emitter,deltah_grounded_base_collector ;
double Uone,emitterout,Utwo_absolute,Itwo_collector,Itwo_total ;

h11 = tran1->h11 ;
h22 = tran1->h22 ;
h12 = tran1->h12 ;
h21 = tran1->h21 ;

pin_resistance_zero = tran1->pin_resistance_zero ;
pin_resistance_one = tran1->pin_resistance_one ;
pin_resistance_two = tran1->pin_resistance_two ;

configuration = tran1->configuration ;

	if ( configuration == 1 ) 
{
        deltah_grounded_emitter_base= (( h11 + pin_resistance_one ) * ( h22 + ( 1 / ( pin_resistance_zero + pin_resistance_two )))) - ( h12 * h21 ) ;

deltah = deltah_grounded_emitter_base ;

	rg_input_square = (( h11 + pin_resistance_one ) * deltah ) / (h22 + (1 / ( pin_resistance_zero + pin_resistance_two )))  ;

	if ( rg_input_square < 1 )
{
	rg_input_square = ( rg_input_square * -1 ) ;
}

	rg_input = sqrt(rg_input_square) ;

tran1->rg_input = rg_input ;
tran1->deltah = deltah ;
}

	else if ( configuration == 2 ) 
{

Uone = tran1->Uone ;
emitterout = tran1->emitterout ;
h12 = Uone / emitterout ;

        deltah_grounded_collector_base=(( h11 + pin_resistance_one ) * ( h22 + ( 1  / (pin_resistance_zero + pin_resistance_two)))) - ( h12 * h21 ) ;

deltah = deltah_grounded_collector_base ;

	rg_input_square = (( h11 + pin_resistance_one ) * deltah ) / ( h22 + ( 1 / ( pin_resistance_zero + pin_resistance_two ))) ;

	if ( rg_input_square < 1 )
{
	rg_input_square = ( rg_input_square * -1 ) ;
}


tran1->rg_input = sqrt(rg_input_square) ;
tran1->deltah = deltah ;

}

	else if ( configuration == 3 )
{

Utwo_absolute = tran1->Utwo_absolute ;
Itwo_collector = tran1->Itwo_collector ;
Itwo_total = tran1->Itwo_total ;

h11 = Utwo_absolute / Itwo_collector ;
h12 = Utwo_absolute / emitterout ;
h22 = Itwo_total / emitterout ;
h21 = Itwo_total / Itwo_collector ;

	deltah_grounded_base_emitter=(( h11 + pin_resistance_zero ) * ( h22 + ( 1 / ( pin_resistance_one + pin_resistance_two )))) - ( h12 * h21 ) ;

deltah = deltah_grounded_base_emitter ;

        rg_input_square = sqrt((( h11 + pin_resistance_zero ) * deltah) / ( h22 + ( 1 / ( pin_resistance_one + pin_resistance_two )))) ;

	if ( rg_input_square < 1 )
{
	rg_input_square = ( rg_input_square * -1 ) ;
}

tran1->rg_input = sqrt(rg_input_square) ;
tran1->deltah = deltah ;

}

	else if ( configuration == 4 )
{

h11 = Utwo_absolute / Itwo_total ;

	deltah_grounded_base_collector=(( h11 + pin_resistance_zero ) * ( h22 + ( 1 / ( pin_resistance_one + pin_resistance_two ))))-( h12 * h21) ;

deltah = deltah_grounded_base_collector ;

        rg_input_square = (( h11 + pin_resistance_zero ) * deltah ) / ( h22 + ( 1 / ( pin_resistance_one + pin_resistance_two))) ;

	if ( rg_input_square < 1 )
{
	rg_input_square = ( rg_input_square * -1 ) ;
}

tran1->rg_input = sqrt(rg_input_square) ;
tran1->deltah = deltah ;

}

	return *tran1  ;

}/* END  Generate_R_G_source_function */

 newtran Generate_Vinput_noise_signal_function( newtran *tran1 )
{

double K_boltz,Ambient_Temperature,Delta_frequency ;
double Voltage_noise_source,rg_input ;

Ambient_Temperature = tran1->Temperature_ambient ; /* in celsius at present */
K_boltz = tran1->K_boltz ;
Delta_frequency = tran1->Delta_frequency ;
rg_input = tran1->rg_input ;

Voltage_noise_source = sqrt(4 * K_boltz * (Ambient_Temperature + 273) * rg_input * Delta_frequency) ;

tran1->Voltage_noise_source = Voltage_noise_source ;

	return *tran1  ;

}/* END Generate_Vinput_noise_signal_function  */

 newtran Generate_Vamplifier_noise_signal_function( int pre_n1 , newtran *tran1 )
{
double Voltage_noise_source,Voltage_noise_amplifier,configuration ;
double h21,Voltage_noise_amplifier_square,Voltage_noise_amplifier_square1,Noise_figure ;
double Noise_figure_one,Noise_figure_two,Noise_figure_three,Noise_figure_four ;

configuration = tran1->configuration ;
Voltage_noise_source = tran1->Voltage_noise_source ;

	if ( configuration == 1) 
{

Noise_figure_one = tran1->Noise_figure_one ;

Noise_figure = (log10(Noise_figure_one) / 10) -1 ;
}

	else if ( configuration == 2) 
{

Noise_figure_two = tran1->Noise_figure_two ;

Noise_figure = (log10(Noise_figure_two) / 10) -1 ;
}

	else if ( configuration == 3) 
{

Noise_figure_three = tran1->Noise_figure_three ;

Noise_figure = (log10(Noise_figure_three) / 10) -1 ;
}

	else if ( configuration == 4) 
{

Noise_figure_four = tran1->Noise_figure_four ;

Noise_figure = (log10(Noise_figure_four) / 10) -1 ;
}

tran1->Noise_figure  = Noise_figure ;
h21 = tran1->h21 ;

	Voltage_noise_amplifier_square1 = (Noise_figure * pow(h21,2) * Voltage_noise_source) ;

h21 = tran1->beta[pre_n1] ;

	if ( Voltage_noise_amplifier_square1 < 1 )
{
	Voltage_noise_amplifier_square = Voltage_noise_amplifier_square1 * -1 ;
}

tran1->Voltage_noise_amplifier_square = Voltage_noise_amplifier_square ;

Voltage_noise_amplifier = sqrt(Voltage_noise_amplifier_square) ;

tran1->Voltage_noise_amplifier = Voltage_noise_amplifier ;

	return *tran1  ;

}/* END Generate_Vamplifier_noise_signal_function  */

 newtran Generate_R_noise_voltage_amplifier_function( newtran *tran1 ) 
{

double Voltage_noise_amplifier_square,R_noise_voltage_amplifier ;
double K_boltz,Ambient_Temperature,Delta_frequency ;

Voltage_noise_amplifier_square = tran1->Voltage_noise_amplifier_square ;
Ambient_Temperature = tran1->Temperature_ambient ; /* in celsius at present ? should I use junction or sink_temperature ? ( sink_temperature = sink mount point , it can be found in tran1 ) */
K_boltz = tran1->K_boltz ;
Delta_frequency = tran1->Delta_frequency ;

R_noise_voltage_amplifier = Voltage_noise_amplifier_square / (4 * K_boltz * (Ambient_Temperature + 273) * Delta_frequency) ;

tran1->R_noise_voltage_amplifier = R_noise_voltage_amplifier ;

	return *tran1  ;

}/* END  Generate_R_noise_voltage_amplifier_function */

 newtran Generate_R_noise_current_amplifier_function( newtran *tran1 ) 
{

double R_noise_voltage_amplifier,configuration ;
double Rg_optimal,R_noise_current_amplifier ;

configuration = tran1->configuration ;

	if ( configuration == 1) 
{
Rg_optimal = tran1->Rg_optimal_one ;
}

	else if ( configuration == 2) 
{
Rg_optimal = tran1->Rg_optimal_two ;
}

	else if ( configuration == 3) 
{
Rg_optimal = tran1->Rg_optimal_three ;
}

	else if ( configuration == 4) 
{
Rg_optimal = tran1->Rg_optimal_four ;
}

R_noise_voltage_amplifier = tran1->R_noise_voltage_amplifier ;

	R_noise_current_amplifier = pow(Rg_optimal,2) / R_noise_voltage_amplifier ;

tran1->R_noise_current_amplifier = R_noise_current_amplifier ;

	return *tran1  ;

}/* END  Generate_R_noise_current_amplifier_function */

 newtran Generate_V_noise_injection_signal_amplifier_function( newtran *tran1 )
{

double R_noise_voltage_amplifier,R_noise_current_amplifier,input_noise_voltage_amplifier,configuration ;
double Ione_total,Ione_total_theta,Itwo_total,Itwo_total_theta,Itwo_collector,Itwo_collector_theta ;
double Voltage_noise_amplifier,Uone_mag,Uone_theta,Utwo_mag,Utwo_theta,Utwo_absolute,emitterout,Uone ;

Uone_mag = tran1->Uone_mag ;
Uone_theta = tran1->Uone_theta ;
Utwo_mag = tran1->Utwo_mag ;
Utwo_theta = tran1->Utwo_theta ;
Uone = tran1->Uone ;
Utwo_absolute = tran1->Utwo_absolute ;
emitterout = tran1->emitterout ;
Ione_total = tran1->Ione_total ;
Ione_total_theta = tran1->Ione_total_theta ;
Itwo_total = tran1->Itwo_total ;
Itwo_total_theta = tran1->Itwo_total_theta ;
Itwo_collector_theta = tran1->Itwo_collector_theta ;
Itwo_collector = tran1->Itwo_collector ;
R_noise_voltage_amplifier = tran1->R_noise_voltage_amplifier ;
R_noise_current_amplifier = tran1->R_noise_current_amplifier ;
configuration = tran1->configuration ;
Voltage_noise_amplifier = tran1->Voltage_noise_amplifier ;


	if ( configuration == 1) 
{
input_noise_voltage_amplifier = (((Uone / Ione_total) * Ione_total) + (Voltage_noise_amplifier  * (Uone / Utwo_absolute))) + (R_noise_current_amplifier * Ione_total) ;
}

	else if ( configuration = 2) 
{
input_noise_voltage_amplifier = (((Uone / Ione_total) * Ione_total) + (Voltage_noise_amplifier  * (Uone / emitterout))) + (R_noise_current_amplifier * Ione_total) ; 
}

	else if ( configuration == 3) 
{ 
input_noise_voltage_amplifier = (((Utwo_absolute / Itwo_collector) * Itwo_collector) + (Voltage_noise_amplifier  * (Utwo_absolute / emitterout))) + (R_noise_current_amplifier * Itwo_collector) ; 
}

	else if ( configuration == 4) 
{ 
input_noise_voltage_amplifier = (((Utwo_absolute / Itwo_total) * Itwo_total) + (Voltage_noise_amplifier  * (emitterout / Utwo_absolute))) + (R_noise_current_amplifier * Itwo_total) ;
}

tran1->input_noise_voltage_amplifier = input_noise_voltage_amplifier ;

	return *tran1  ;

}/* END  Generate_V_noise_injection_signal_amplifier_function */

 newtran Generate_noisey_signal_function( newtran *tran1 ) 
{

double input_noise_voltage_amplifier,noise_voltage_complete,Uone_mag,Uone_theta,Uone,omega ;
double Delta_frequency,a_double_random_number,input_noise_theta,noise_voltage_real,noise_voltage_imaginary,Uone_noise_theta ;
double Uone_initial,a_random_number,Uone_noise_mag,Uone_noise_mag_square,Uone_noise ;

srand(time(NULL)) ;

a_random_number = (double) (rand() % 100000) ;

if (a_random_number < 1 )
{
a_random_number = a_random_number + 1 ;
}

a_double_random_number = a_random_number / 100000 ;

omega = tran1->omega ;
Delta_frequency = tran1->Delta_frequency ;

	input_noise_theta = (Delta_frequency * omega) * a_double_random_number ;

input_noise_voltage_amplifier = tran1->input_noise_voltage_amplifier ;
Uone = tran1->Uone ;

	noise_voltage_complete = Uone + (input_noise_voltage_amplifier * sin(input_noise_theta)) ;

tran1->Uone = noise_voltage_complete ;
Uone_mag = tran1->Uone_mag ;
Uone_theta = tran1->Uone_theta ;

	noise_voltage_real = ( Uone_mag * cos(Uone_theta)) + (input_noise_voltage_amplifier * cos(input_noise_theta)) ;

	noise_voltage_imaginary = ( Uone_mag * sin(Uone_theta)) + (input_noise_voltage_amplifier * sin(input_noise_theta)) ;

	Uone_noise_theta = atan( noise_voltage_imaginary / noise_voltage_real ) ;

tran1->Uone_theta = Uone_noise_theta ;

	Uone_noise_mag_square = pow(noise_voltage_real,2) + pow(noise_voltage_imaginary,2) ;

 	Uone_noise_mag = sqrt(Uone_noise_mag_square);

	Uone_noise = Uone_noise_mag * sin(Uone_noise_theta) ;

tran1->Uone_mag = Uone_noise_mag ;


	return *tran1  ;

}/* END  Generate_noisey_signal_function */

 newtran noisey_function( newtran *tran1 ) 
{
int BBMT_off ;

	 Generate_R_G_source_function( 7 , tran1 ) ;/* pre-n1 for beta()	 	 */
	 Generate_Vinput_noise_signal_function( tran1 ) ;
	 Generate_Vamplifier_noise_signal_function( 7 , tran1 ) ;/* pre-n1 for beta()	 	 */
	 Generate_R_noise_voltage_amplifier_function( tran1 ) ;
	 Generate_R_noise_current_amplifier_function( tran1 ) ;
	 Generate_V_noise_injection_signal_amplifier_function( tran1 ) ;
	 Generate_noisey_signal_function( tran1 ) ;
 
 BBMT_off = tran1->BBMT_off ;



	if ( BBMT_off = 0 ) 
{
         Set_I_one(8,8, tran1 ) ;           		   /* 8 & baseimp[8]	 	 */
         Set_Beta(8,8, tran1 ) ;            		   /* 8 & itwo[8]		 */
	BBMT_Beta_change_function(8, tran1 ) ;		   /* 8 for beta[n]			 */
	BBMT_Power_function(8,8, tran1 ) ; 		   /* 8 & Ione[8] & baseimp[8]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 8				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;
        Set_I_two(9,8,8, tran1 ) ;          		   /* 9 & ione[6] & beta[6]	 */
        Set_Beta(9,9, tran1 ) ;            		   /* 9 & itwo[9]		 */
	BBMT_Beta_change_function(9, tran1 ) ;		   /* 9 for beta[n]			 */
        Set_I_two(10,8,9, tran1 ) ;         		   /* 10 & ione[8] & beta[9]	 */
        Set_Beta(10,10, tran1 ) ;            		   /* 10 & itwo[10]		 */
	BBMT_Beta_change_function(10, tran1 ) ;		   /* 10 for beta[n]			 */
	BBMT_Power_function(10,8, tran1 ) ; 		   /* 10 & Ione[8] & baseimp[8]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 10				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;
	 Generate_I_1_total_function(10,10,8,1, tran1 ) ;
	 Generate_I_2_total_function(10,10,8,1, tran1 ) ;
	 Generate_self_induced_load_function(10,10,8,1, tran1 ) ;
	 Generate_h11_function(10,10,8,1, tran1 ) ;
	 Generate_h21_function(10,10,8,1, tran1 ) ;
	 Generate_h22_function(10,10,8,1, tran1 ) ;
	 Generate_h12_function(10,10,8,1, tran1 ) ;
	 Generate_U_2_out_function(10,10,8,1, tran1 ) ;
	 Generate_U_1_out_function(10,10,8,1, tran1 ) ;
	 Generate_U_0_out_function(10,10,8,1, tran1 ) ;	

	  print_H_functions(10,10,8,1, tran1 ) ; /* itwo[n] beta[pre_n1] ione[pre_n2] */
}
	return  ;

}/* end noisey function */


