/* Copyright (C) 'H' model transistor B.S.J.W. Stephenson 19/2/2008 & 20/3/2008 & 4/4/08 & 3/6/08*/
/* A.K.A the Black Box Model Transistor ,Bibliographic ref. Mullard,Dio-tech etal '54->? */
/*
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

# include <stdio.h>
# include <limits.h> 
# include <stdarg.h>
# include <float.h>
# include <math.h>
# include <string.h>
# include "./BBBMTdefs6.h"

 newtran BBMT_program_function( newtran *tran1 ) 
{

int n,noise_on ;
noise_on = tran1->noise_on ;

 	Set_Base_Impedance_Gradient( tran1 ) ;
 	BBMT_Set_Capacitor_1_2_voltage_gradient_function( tran1 ) ;
 	BBMT_Set_Capacitor_1_0_voltage_gradient_function( tran1 ) ;

/* This may very well be sub-optimal , any suggestions welcome !
HOWEVER IF YOU ARE NOT VERY CAREFUL THIS FED FORWARD NETWORK WILL BECOME A USELESS!!!!
                OSCILLATOR!!!!!!!!!!!!!!!! 
using initial condition Ione and Itwo        	 	      n   pre_n1    pre_n2	 */
         Set_Base_impedance(0,0, tran1 ) ;  		   /* 0 & itwo[0]		 */
        Set_I_one(1,0, tran1 ) ;            		   /* 1 & baseimp[0]		 */
         Set_Beta(1,0, tran1 ) ;            		   /* 1 & itwo[0]		 */
	BBMT_Generate_size_Z_Cap_1_2_function(1, tran1 ) ; /* 1 			 */
	BBMT_Generate_size_Z_Cap_1_0_function(1, tran1 ) ; /* 1 			 */
	BBMT_Generate_Frequencies_Z_Cap_1_2_function(1,2, tran1 ) ;/* 1 & 2 post_n*/
	BBMT_Generate_Frequencies_Z_Cap_1_0_function(1,2, tran1 ) ;/* 1 & 2 post_n*/
	BBMT_Generate_I_Cap_1_2_function(1,0,2, tran1 ) ;  /* 1 & Ic12[0] & 2 post_n		 */
	BBMT_Generate_I_Cap_1_0_function(1,0,2, tran1 ) ;  /* 1 & Ic10[0] & 2 post_n		 */
        Set_I_two(1,1,1, tran1 ) ;          		   /* 1 & ione[1] & beta[1]	 */
         Set_Base_impedance(1,1, tran1 ) ;  		   /* 1 & itwo[1]		 */
	BBMT_Power_function(1,1, tran1 ) ; 		   /* 1 & Ione[1] & baseimp[1]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 1				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

        Set_I_one(2,1, tran1 ) ;           		   /* 2 & baseimp[1]		 */
        Set_I_two(2,2,1, tran1 ) ;         		   /* 2 & ione[2] & beta[1]	 */
         Set_Beta(2,2, tran1 ) ;            		   /* 2 & itwo[2]  		 */
	BBMT_Beta_change_function(2, tran1 ) ;		   /* 2 			 */
         Set_Base_impedance(2,2, tran1 ) ;  		   /* 2 & itwo[2]		 */
	BBMT_Baseimp_change_thermal_function(2, tran1 );   /* 2  for baseimp[n]                   */
	BBMT_Power_function(2,2, tran1 ) ; 		   /* 2 & Ione[2] & baseimp[2]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 2				 */

	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

        Set_I_two(3,2,2, tran1 ) ;         		   /* 3 & ione[2] & beta[2]	 */
         Set_Base_impedance(3,3, tran1 ) ;  		   /* 3 & itwo[3]		 */
	BBMT_Baseimp_change_thermal_function(3, tran1 );   /* 3  for baseimp[n]                   */
        Set_I_one(3,3, tran1 ) ;            		   /* 3 & baseimp[3]	 	 */
         Set_Beta(3,3, tran1 ) ;            		   /* 3 & itwo[3]		 */
	BBMT_Beta_change_function(3, tran1 ) ;		   /* 3 for beta[n]			 */
	BBMT_Power_function(3,3, tran1 ) ; 		   /* 3 & Ione[3] & baseimp[3]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 3				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

        Set_I_two(4,3,3, tran1 ) ;          		   /* 4 & ione[3] & beta[3]	 */
         Set_Base_impedance(4,4, tran1 ) ;  		   /* 4 & itwo[4]		 */
	BBMT_Baseimp_change_thermal_function(4, tran1 );   /* 4  for baseimp[n]                   */
         Set_Beta(4,4, tran1 ) ;            		   /* 4 & itwo[4]		 */
	BBMT_Beta_change_function(4, tran1 ) ;		   /* 4 for beta[n]			 */
        Set_I_one(4,4, tran1 ) ;            		   /* 4 & baseimp[4]	 	 */
	BBMT_Power_function(4,4, tran1 ) ; 		   /* 4 & Ione[4] & baseimp[4]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 4				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

        Set_I_two(5,4,4, tran1 ) ;          		   /* 5 & ione[4] & beta[4]	 */
         Set_Base_impedance(5,5, tran1 ) ;  		   /* 5 & itwo[5]		 */
	BBMT_Baseimp_change_thermal_function(5, tran1 );   /* 5  for baseimp[n]                   */
         Set_I_one(5,5, tran1 ) ;           		   /* 5 & baseimp[5]	 	 */
         Set_Beta(5,5, tran1 ) ;            		   /* 5 & itwo[5]		 */
	BBMT_Beta_change_function(5, tran1 ) ;		   /* 5 for beta[n]			 */
	BBMT_Power_function(5,5, tran1 ) ; 		   /* 5 & Ione[5] & baseimp[5]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 5				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

        Set_I_two(6,5,5, tran1 ) ;          		   /* 6 & ione[5] & beta[5]	 */
         Set_Beta(6,6, tran1 ) ;            		   /* 6 & itwo[6]		 */
	BBMT_Beta_change_function(6, tran1 ) ;		   /* 6 for beta[n]			 */
        Set_Base_impedance(6,6, tran1 ) ;   		   /* 6 & itwo[6]		 */
	BBMT_Baseimp_change_thermal_function(6, tran1 );   /* 6  for baseimp[n]                   */
         Set_I_one(6,6, tran1 ) ;           		   /* 6 & baseimp[6]	 	 */
	BBMT_Power_function(6,6, tran1 ) ; 		   /* 6 & Ione[6] & baseimp[6]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 6				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

       Set_I_two(7,6,6, tran1 ) ;           		   /* 7 & ione[6] & beta[6]	 */
        Set_Base_impedance(7,7, tran1 ) ;   		   /* 7 & itwo[7]		 */
	BBMT_Baseimp_change_thermal_function(7, tran1 );   /* 7  for baseimp[n]                   */
         Set_I_one(7,7, tran1 ) ;           		   /* 7 & baseimp[7]	 	 */
         Set_Beta(7,7, tran1 ) ;            		   /* 7 & itwo[7]		 */
	BBMT_Beta_change_function(7, tran1 ) ;		   /* 7 for beta[n]			 */
	BBMT_Power_function(7,7, tran1 ) ; 		   /* 7 & Ione[7] & baseimp[7]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 7				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

       Set_I_two(8,7,7, tran1 ) ;           		   /* 8 & ione[7] & beta[7]	 */
        Set_Base_impedance(8,8, tran1 ) ;   		   /* 8 & itwo[8]		 */
	BBMT_Baseimp_change_thermal_function(8, tran1 );   /* 8  for baseimp[n]                   */
       Set_I_one(8,8, tran1 ) ;           		   /* 8 & baseimp[8]	 	 */
         Set_Beta(8,8, tran1 ) ;            		   /* 8 & itwo[8]		 */
	BBMT_Beta_change_function(8, tran1 ) ;		   /* 8 for beta[n]			 */
	BBMT_Power_function(8,8, tran1 ) ; 		   /* 8 & Ione[8] & baseimp[8]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 8				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;

        Set_I_two(9,8,8, tran1 ) ;          		   /* 9 & ione[6] & beta[6]	 */
         Set_Beta(9,9, tran1 ) ;            		   /* 9 & itwo[9]		 */
	BBMT_Beta_change_function(9, tran1 ) ;		   /* 9 for beta[n]			 */
        Set_I_two(10,8,9, tran1 ) ;         		   /* 10 & ione[8] & beta[9]	 */
         Set_Beta(10,10, tran1 ) ;            		   /* 10 & itwo[10]		 */
	BBMT_Beta_change_function(10, tran1 ) ;		   /* 10 for beta[n]			 */
	BBMT_Power_function(10,8, tran1 ) ; 		   /* 10 & Ione[8] & baseimp[8]  */
	BBMT_Thermal_function( tran1 ) ;   		   /* 10				 */
	BBMT_Generate_thermal_leakage_Cap_1_2_function( tran1 ) ;
/***************************************/

n = tran1->n ;

	 Generate_I_1_total_function(10,10,8,1, tran1 ) ;
	 Generate_I_2_total_function(10,10,8,1, tran1 ) ;
	 Generate_self_induced_load_function(10,10,8,1, tran1 ) ;
	 Generate_h11_function(10,10,8,1, tran1 ) ;
	 Generate_h21_function(10,10,8,1, tran1 ) ;
	 Generate_h22_function(10,10,8,1, tran1 ) ;
	 Generate_h12_function(10,10,8,1, tran1 ) ;
	 Generate_U_2_out_function(10,10,8,1, tran1 ) ;
	 Generate_U_1_out_function(10,10,8,1, tran1 ) ;
	 Generate_U_0_out_function(10,10,8,1, tran1 ) ;	

 if (noise_on = 1)
{
	noisey_function( tran1 ) ;
}

	  print_H_functions(10,10,8,1, tran1 ) ; /* itwo[n] beta[pre_n1] ione[pre_n2] */

	return  ;

}/* end program function */

 newtran BBMT_constants_function( newtran *tran1 ) 
{

 int n ;
 double Uonemax,Uonemax_theta,Utwoinit,Utwoinittheta,Uemitterin,Uemitterin_theta,Sign_Uone ;
 double Uone_imaginary,Uone_imaginary_a,Uone_imaginary_b,Uone_real,Uone_theta,Uone_square,Uone_mag,Uone ;
 double Uonemax_mag,Uemitterin_mag,Uonemax_real,Uemitterin_real,Uonemax_imaginary,Uemitterin_imaginary ;

/* set up transistor constants for calculations(talk about the obvious , left over from pre functionalisation) */
n = 0 ;
Uonemax = tran1->Uonemax ;

Uonemax_theta = tran1->Uonemax_theta ;

Uonemax_mag = Uonemax / sin(Uonemax_theta);

Utwoinit = tran1->Utwoinit ;

Utwoinittheta = tran1->Utwoinittheta ;

Uemitterin = tran1->Uemitterin[n] ;

Uemitterin_theta = tran1->Uemitterin_theta[n] ;

Uemitterin_mag = Uemitterin / sin(Uemitterin_theta) ;

/* dc original	Uone = Uonemax - Uemitterin ; initial conditions ( at this point yes I am stupid )*/

	Uonemax_imaginary = Uonemax_mag * sin(Uonemax_theta) ;
	Uemitterin_imaginary = Uemitterin_mag * sin(Uemitterin_theta) ;
	Uonemax_real = Uonemax_mag * cos(Uonemax_theta) ;
	Uemitterin_real = Uemitterin_mag * cos(Uemitterin_theta) ;

	Uone_imaginary = Uonemax_imaginary - Uemitterin_imaginary ;

tran1->Uone_imaginary = Uone_imaginary ;

	Uone_real = Uonemax_real - Uemitterin_real ;

tran1->Uone_real = Uone_real ;

	Uone_theta = atan(Uone_imaginary / Uone_real) ;

tran1->Uone_initial_theta = Uone_theta ;
tran1->Uone_theta = Uone_theta ;

	Uone_square = pow(Uone_real,2) + pow(Uone_imaginary,2) ;

	Uone_mag = sqrt(Uone_square) ;
	
	Sign_Uone = Uone_real + Uone_imaginary ;
	
	if ( Sign_Uone < 0 )
{	
	Uone_mag = Uone_mag *-1 ;
}

tran1->Uone_mag = Uone_mag ;

	Uone = Uone_mag * sin(Uone_theta) ;

tran1->Uone = Uone ;


	return *tran1  ;
}

 newtran BBMT_Utwo_absolute_function( newtran *tran1 )
{
 int n ;
 double Uonemax,Uonemax_theta,Utwoinit,Utwoinittheta,Uemitterin,Uemitterin_theta ;
 double Utwo_imaginary,Utwo_real,Utwo_theta,Utwo_square,Utwo_mag,Utwo_absolute ;

n = 0 ;
Uonemax = tran1->Uonemax ;
Uonemax_theta = tran1->Uonemax_theta ;
Utwoinit = tran1->Utwoinit ;
Utwoinittheta = tran1->Utwoinittheta ;
Uemitterin = tran1->Uemitterin[n] ;
Uemitterin_theta = tran1->Uemitterin_theta[n] ;

/*now generate ( Utwoinit - Uemitterin ) , Utwo_absolute for power function */

	Utwo_imaginary = ( Utwoinit * sin(Utwoinittheta) - (Uemitterin * sin(Uemitterin_theta))) ;
	Utwo_real = ( Utwoinit * cos(Utwoinittheta) - (Uemitterin * cos(Uemitterin_theta))) ;

	Utwo_theta = atan(Utwo_imaginary / Utwo_real) ;

tran1->Utwo_theta = Utwo_theta ;

	Utwo_square = pow(Utwo_imaginary,2) + pow(Utwo_real,2) ;

	Utwo_mag = sqrt(Utwo_square) ;

tran1->Utwo_mag = Utwo_mag ;

	Utwo_absolute = Utwo_mag * sin(Utwo_theta) ;

tran1->Utwo_absolute = Utwo_absolute ;

	return *tran1  ;

}/* end Utwo_absolute_function */

 newtran BBMT_uone_not_zero_function( newtran *tran1 )
{

 double Uone,Uone_mag ;

/* check uone not zero */

Uone_mag = tran1->Uone_mag ;
Uone = tran1->Uone ;

	if ( Uone == 0 )
{
/* avoid division by zero error */
tran1->Uone = 9e-8 ;
Uone = tran1->Uone ;
} 

	if ( Uone == 0 )
{
tran1->Uone_mag = 3e-4 ;
Uone_mag = tran1->Uone_mag ;
 }

	return *tran1  ;

}/* end  uone_not_zero_function*/

 newtran BBMT_inititial_conditions_function( newtran *tran1 )
{

 int n ;
 double baserone,Ione[12],Ione_theta[12],Uone,Uone_theta,bone ;
 double Itwo[12],Itwo_theta[12],Utwoinittheta ;

/* first guess */

n = 0 ;
baserone = tran1->baserone ;
Uone = tran1->Uone ;

	Ione[n] = Uone/baserone ;

tran1->Ione[n] = Ione[n] ;
Uone_theta = tran1->Uone_theta ;

	Ione_theta[n] = Uone_theta ; 

tran1->Ione_theta[n] = Ione_theta[n] ;

n = 0 ;
bone = tran1->bone ;
 
	Itwo[n] = bone*Ione[n] ;

tran1->Itwo[n] = Itwo[n] ;
Utwoinittheta = tran1->Utwoinittheta ;

	Itwo_theta[n] = Utwoinittheta ; 

tran1->Itwo_theta[n] = Itwo_theta[n] ;

	return *tran1  ;

}/* end inititial conditions function*/



