/* Copyright (C) B.S.J.W.S 22/2/08  & 3/6/08*/
/* structural confines for the H-model Black Box Model Transistor */
/* A.K.A the Black Box Model Transistor ,Bibliographic ref. Mullard,Dio-tech etal '54->? */
/*
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

#include <stdlib.h>
# include <stdio.h>

typedef struct bbtnode *ptrbbtnode ;
typedef struct bbtnode {

    double F_bone  ;
    double F_btwo ;
    double F_bthree ;
    double F_bfour ;
    double F_bfive  ;
    double F_bsix  ;
    double F_Beta_high ;
    double F_Beta_low ;
    double FT_Beta_high ;
    double FT_Beta_low ;

    double R_bone  ;
    double R_btwo ;
    double R_bthree ;
    double R_bfour ;
    double R_bfive  ;
    double R_bsix  ;
    double R_Beta_high ;
    double R_Beta_low ;
    double RT_Beta_high ;
    double RT_Beta_low ;

    double F_icone ;
    double F_ictwo ;
    double F_icthree ;
    double F_icfour ;
    double F_icfive ;
    double F_istop ;

    double R_icone ;
    double R_ictwo ;
    double R_icthree ;
    double R_icfour ;
    double R_icfive ;
    double R_istop ;

    double F_baserone ;
    double F_basertwo  ;
    double F_baserthree ;
    double F_Ibasemin ;
    double F_Ibasemax ;
    double F_baseimp_high_T ;
    double F_baseimp_low_T ;
    double FT_baseimp_high_T ;
    double FT_baseimp_low_T ;

    double R_baserone ;
    double R_basertwo  ;
    double R_baserthree ;
    double R_Ibasemin ;
    double R_Ibasemax ;
    double R_baseimp_high_T ;
    double R_baseimp_low_T ;
    double RT_baseimp_high_T ;    
    double RT_baseimp_low_T ;   
    double reverse_off_diode_resistance ;    
    
    double Delta_frequency_one ;
    double Delta_frequency_two ;
    double Delta_frequency_three ;
    double Delta_frequency_four ;

/*************************** foward model , down*/
    double bone  ;
    double btwo ;
    double bthree ;
    double bfour ;
    double bfive  ;
    double bsix  ;
    double Beta_high ;
    double Beta_low ;
    double T_Beta_high ;
    double T_Beta_low ;    
    double icone ;
    double ictwo ;
    double icthree ;
    double icfour ;
    double icfive ;
    double istop ;
    double pin_resistance_zero ;
    double pin_resistance_one ;
    double pin_resistance_two ;
    double baserone ;
    double basertwo  ;
    double baserthree ;
    double C12V1start ;
    double C12V2corner ;
    double C12V3end ;
    double C10V1start ;
    double C10V2corner1 ;
    double C10V3corner2 ;
    double C10V4end ;
    double V12C1start ;
    double V12C2corner ;
    double V12C3end ;
    double V10C1start ;
    double V10C2corner1 ;
    double V10C3corner2 ;
    double V10C4end ;
    double resistance_Icbo_low ;
    double resistance_Icbo_high ;
    double temperature_Icbo_low ; 
    double temperature_Icbo_high ;
    double Rg_optimal_one ;
    double Rg_optimal_two ;
    double Rg_optimal_three ;
    double Rg_optimal_four ;
    double Noise_figure_one ;
    double Noise_figure_two ;
    double Noise_figure_three ;
    double Noise_figure_four ;
    double Delta_frequency ;
    
    double inverted_base_voltage_low ; 
    double inverted_base_voltage_high ;
    double inverse_base_resistance ;
    double inverse_base_resistance_high ;

    double reverse_inverted_base_voltage_low ; 
    double reverse_inverted_base_voltage_high ;
    double reverse_inverse_base_resistance ;
    double reverse_inverse_base_resistance_high ;

    double offset ;
    double gradient1C12 ;
    double gradient2C12 ;
    double gradient1C10 ;
    double gradient2C10 ;
    double gradient3C10 ;
    double lnC12V1start ;
    double lnC12V2corner ;
    double lnC12V3end ;
    double lnC10V1start ;
    double lnC10V2corner1 ;
    double lnC10V3corner2 ;
    double lnC10V4end ;
    double lnV12C1start ;
    double lnV12C2corner ;
    double lnV12C3end ;
    double lnV10C1start ;
    double lnV10C2corner1 ;
    double lnV10C3corner2 ;
    double lnV10C4end ;
    double baseimp_high_T ;
    double baseimp_low_T ;
    double T_baseimp_high_T ;
    double T_baseimp_low_T ;    
    double lnbaserone ;
    double lnbasertwo ;
    double lnbaserthree ;
    double Ibasemin ;
    double Ibasemax ;
    double lnIbasemin ;   
    double lnIbasemax ;
    double elnIbasemax ;
    double elnIbasemin ;
    double vemitterbasemax ;
    double nodeinbase ;
    double nodeinbase_ohmega_T ;
    double nodeincollector ;
    double nodeincollector_ohmega_T ;
    double nodeinemitter ; 
    double nodeinemitter_ohmega_T ;
    double nodeoutbase ;
    double nodeoutcollector ;
    double nodeoutemitter ;
    double rgopt,rlopt ;
    double rg_input ;
    double K_boltz ;
    double Voltage_noise_source ;
    double Voltage_noise_amplifier ;
    double Voltage_noise_amplifier_square ;
    double R_noise_voltage_amplifier ;
    double R_noise_current_amplifier ;
    double input_noise_voltage_amplifier ;
    double reverse_off_diode_current ;
    double reverse_off_diode_current_theta ;        
    double Noise_figure ;

    double Uone ;
    double Uone_real ;
    double Uone_imaginary ;
    double Uone_mag ;
    double frequency_Uone ;
    double Uone_theta ;
    double Uone_initial_theta ;
    double Uone_initial ;
    double Uone_internal[12] ;
    double Uone_internal_theta[12] ;
    double Uoneout ;
    double Uoneout_mag ;
    double Uoneout_theta ;
    double Uoneout_absolute ; 
    double Uonemax ;
    double Uonemax_theta ;
    double push_pull_Uone ;

    double Utwoout ;
    double Utwoout_mag ;
    double Utwoout_theta ;
    double Utwoout_absolute ;
    double push_pull_Utwo ;

    double Utwoinit ;
    double Utwoinittheta ;
    double Utwo_absolute ;
    double Utwo ;
    double frequency_Utwo ;
    double Utwo_mag ; 
    double Utwo_theta ;

    double omega ;
    double frequency_Uzero ;

    double emitterin ;
    double Uemitterin[12] ;
    double Uemitterin_theta[12] ;
    double emitterout ;
    double deltah ;
    double betaset ;
    double gradset ;
    double betaoffset ;
    double lnbaseimps1 ;
    double lnbaseimps2 ;

    double Ione[10] ;
    double Ione_mag ;
    double Ione_theta[10] ;
    double Ione_total ;
    double Ione_total_mag ;
    double Ione_total_theta ;

    double IUone_out ;
    double IUone_out_theta ;

    double Itwo[12] ;
    double Itwo_mag ;
    double Itwo_theta[12] ;
    double Itwo_total ;
    double Itwo_total_mag ;
    double Itwo_total_theta ;
    double Itwo_collector_real ;
    double Itwo_collector_imaginary ;
    double Itwo_collector_theta ;
    double Itwo_collector_square ;
    double Itwo_collector_mag ;
    double Itwo_collector ;

    double lnItwo[10] ;
    double beta[12] ;
    double baseimps[10] ;
    double baseimp[10] ;
    double R_inverted_base ;
    double R_reverse_inverted_base ;      
    double PowerDissipation ;
    double theta_total ;
    double theta_junction_coeficient ;
    double theta_case_sink ;
    double theta_ambient_sink ;
    double Junction_temperature ;
    double Temperature_ambient ;
    double sink_temperature ;
    double Beta_change ;

    double h11_absolute ;
    double h11 ;
    double h11_mag ;
    double h11_theta ;

    double h12 ;
    double h12_mag ;
    double h12_theta ;
    double h12_absolute ;

    double h21 ;
    double h21_mag ;
    double h21_theta ;
    double h21_absolute ;

    double h22 ;
    double h22_mag ;
    double h22_theta ;


    double rload ;
    double rload_mag ;
    double rload_theta ;
    double rload_absolute ;

    double lngradient1C12 ;
    double lngradient2C12 ;
    double lngradient1C10 ;
    double lngradient2C10 ;
    double lngradient3C10 ;
    double UIC12_imaginary ;
    double UIC12_real ;
    double UIC12_theta_initial ;
    double UIC10_imaginary ;
    double UIC10_real ;
    double UIC10_theta_initial ;

    double eC12 ;
    double C12 ;
    double voltage_acrossC12_absolute ;
    double voltage_acrossC12_mag ;
    double voltage_acrossC12_theta ;
    double Zc12[12] ;
    double I_leakage_Cap_1_2 ;
    double R_leakage_Cap_1_2 ;
    double Ic12[12] ;
    double Ic12_theta[12] ;

    double eC10 ;
    double C10 ;
    double voltage_acrossC10_absolute ;
    double voltage_acrossC10_mag ;
    double voltage_acrossC10_theta ;
    double Zc10[12] ;
    double Ic10[12] ;
    double Ic10_theta[12] ;

    double incline ;
    char npn[6];
    char descriptor[8] ;
    int noise_on ;
    int configuration ;
    int n ;
    int BBMT_off ;
    int BBMT_off_forward ;
    int Compound_thermal_beta_on ;
    int Compound_thermal_baseimp_on ;   
} newtran ;

extern ptrbbtnode talloc(void) ;
extern newtran BBMT_initialise_function( newtran *tran1 ) ;
extern newtran BBMT_program_function( newtran *tran1 ) ;
extern newtran BBMT_constants_function( newtran *tran1 ) ;
extern newtran BBMT_Utwo_absolute_function( newtran *tran1 ) ;
extern newtran BBMT_inititial_conditions_function( newtran *tran1 ) ;

extern newtran BBMT_Beta_change_function( int n , newtran *tran1 ) ;
extern newtran BBMT_Power_function( int n , int pre_n , newtran *tran1 ) ;
extern newtran BBMT_Thermal_function( newtran *tran1 ) ;
extern newtran BBMT_Baseimp_change_thermal_function( int n , newtran *tran1 ) ;
extern newtran Set_Base_Impedance_Gradient( newtran *tran1 ) ;
extern newtran Set_Base_impedance( int n , int pre_n , newtran *tran1 ) ;
extern newtran Set_I_one( int n , int pre_n , newtran *tran1 ) ;
extern newtran Set_Beta( int n , int pre_n , newtran *tran1 ) ;
extern newtran Set_I_two( int n , int pre_n1 ,int pre_n2 , newtran *tran1 ) ;
 
extern newtran BBMT_Set_Capacitor_1_2_voltage_gradient_function( newtran *tran1 ) ;
extern newtran BBMT_Set_Capacitor_1_0_voltage_gradient_function( newtran *tran1 ) ;
extern newtran BBMT_Generate_Uone_internal_function(int n,int pre_n , newtran *tran1 ) ;
extern newtran BBMT_Generate_size_Z_Cap_1_2_function(int n, newtran *tran1 ) ;
extern newtran BBMT_Generate_size_Z_Cap_1_0_function(int n, newtran *tran1 ) ;
extern newtran BBMT_Generate_Frequencies_Z_Cap_1_2_function(int n,int post_n, newtran *tran1 ) ;
extern newtran BBMT_Generate_Frequencies_Z_Cap_1_0_function(int n,int post_n, newtran *tran1 ) ;
extern newtran BBMT_Generate_I_Cap_1_2_function(int n ,int pre_n ,int post_n, newtran *tran1 ) ;
extern newtran BBMT_Generate_I_Cap_1_0_function(int n ,int pre_n ,int post_n, newtran *tran1 ) ;
extern newtran BBMT_uone_not_zero_function( newtran *tran1 ) ;
extern newtran print_H_functions( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_self_induced_load_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_h11_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_h21_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_h22_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_U_2_out_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_h12_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_U_1_out_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_U_0_out_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_I_1_total_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran Generate_I_2_total_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 ) ;
extern newtran BBMT_Generate_thermal_leakage_Cap_1_2_function( newtran *tran1 ) ;
extern newtran Generate_R_G_source_function( int pre_n1 , newtran *tran1 ) ;
extern newtran Generate_Vinput_noise_signal_function( newtran *tran1 ) ;
extern newtran Generate_Vamplifier_noise_signal_function( int pre_n1 , newtran *tran1 ) ;
extern newtran Generate_R_noise_voltage_amplifier_function( newtran *tran1 ) ;
extern newtran Generate_R_noise_current_amplifier_function( newtran *tran1 ) ;
extern newtran Generate_V_noise_injection_signal_amplifier_function( newtran *tran1 ) ;
extern newtran Generate_noisey_signal_function( newtran *tran1 ) ;
extern newtran noisey_function( newtran *tran1 ) ;



extern newtran Set_forward_and_Reverse_descrip( newtran *tran1 ) ;
extern newtran BBMT_load_forward_descript( newtran *tran1 ) ;
extern newtran BBMT_load_reverse_descript( newtran *tran1 ) ;
extern newtran BBMT_Set_Delta_frequency( newtran *tran1 ) ;
extern newtran BBMT_forwards_off_characteristic( newtran *tran1 ) ;
extern newtran BBMT_reverse_off_diode_leakage( newtran *tran1 ) ; 
extern newtran BBMT_reverse_off_characteristic( newtran *tran1 ) ;  
extern newtran print_transistor_off_function( newtran *tran1 ) ;  
  
 
